{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gDistance;
{TDistanceForm Form Created and Freed from gUILinear}
interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, gGlobal;

type
  TDistanceForm = class(TForm)
    Label1: TLabel;
    DistanceEdit: TEdit;
    DOEdit: TEdit;
    Label2: TLabel;
    CancelBtn: TButton;
    OkBtn: TButton;
    procedure OkBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    function GetRedS: string;

  public
    { Public declarations }
    property RedS: string read GetRedS;

  end;

var
  DistanceForm: TDistanceForm;

implementation
{TDistanceForm Form Created and Freed from gUILinear}
{$R *.DFM}

function TDistanceForm.GetRedS: string;
begin
  if (DistanceEdit.Text = '') then Result := '-1'
  else Result := DistanceEdit.Text;
end;

procedure TDistanceForm.FormCreate(Sender: TObject);
begin
  left := DistanceFormX;
  top := DistanceFormY;
end;

procedure TDistanceForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DistanceFormX := DistanceForm.left;
  DistanceFormY := DistanceForm.top;
end;

procedure TDistanceForm.CancelBtnClick(Sender: TObject);
begin
  DistanceFormX := DistanceForm.left;
  DistanceFormY := DistanceForm.top;
  ModalResult := mrNone;
  DoSaver;
  Close;
end;

procedure TDistanceForm.FormShow(Sender: TObject);
var IDS: string;
begin
  InDistance := PixelLine; {950.0;}
  Str(InDistance, IDS);
  DistanceEdit.Text := IDS;
end;

procedure TDistanceForm.OkBtnClick(Sender: TObject);
var {DistanceS,}  Distance: string;
  DistanceCode, iDistance: Integer;
begin
  DistanceFormX := DistanceForm.left;
  DistanceFormY := DistanceForm.top;
  DoSaver;
  Val(DOEdit.Text, iDistance, DistanceCode);
  if (DistanceCode <> 0) then Codefx(DOEdit.Text, DistanceCode);
  if (iDistance = -1) then {keep compiler quiet};
  if (DistanceCode = 0) then begin
    try begin
        Distance := GetRedS; {{DistanceEdit.Text;}
        Val(Distance, iDistance, DistanceCode);
        if (iDistance = -1) {(Distance = '-1')} then
        begin {No input}
          DoMessages(18);
          ModalResult := mrNone;
        end else {Wrong numbers}
          if (DistanceCode > 0) then
          begin
            Codefx(Distance, DistanceCode);
{        Str(DistanceCode,DistanceS);
        DistanceS:= 'Distance Value character '+DistanceS+' is wrong';
        ShowMessage(DistanceS);  }
            ModalResult := mrNone;
          end else ModalResult := mrOK;
      end;
    except
      DoMessages(19);
      ModalResult := mrNone;
    end;
  end;
end;






end.
