{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gGlobal;

interface

uses
  Sysutils,
  Windows,
{ WinTypes,}{Data types}
  ShellAPI,
  Graphics, {GetDibSizes}
  Controls, {Cursor names}
  Forms, {Screen}
  Dialogs; {MessageDlg}

const
  DIHVersion: string = 'DIH 1.1';
  DISVersion: string = 'DIS 1.1';
  DIPVersion: string = 'DIP 1.1';


type
  ObjectMarker = record
    IsSolidFill: Boolean;
    ObjectType, X1, X2, Y1, Y2: Integer;
    LineColor, FillColor: TColor;
  end;

  ObjectLabel = record
    LOText: string[250];
    RotAngle, X, Y: Integer;
    Rotated, TransBack: Boolean;
    BackColor: TColor;
    LOFont: TFont;
  end;

  ClassifiedRecord = record {ClassifiedArray: Array of }
    Rcent, Rmin, Rmax,
    Gcent, Gmin, Gmax,
    Bcent, Bmin, Bmax: Byte;
    Count, RValues, GValues, BValues: Integer;
    Radius, SDeviation, Variance: Double;
  end;

  PHugeTByteArray = ^THugeTByteArray;
  THugeTByteArray = array[0..0, 0..0, 0..0] of Byte;
  PHugeByteArray = ^THugeByteArray;
  THugeByteArray = array[0..0] of Byte;
  PHugeCharArray = ^THugeCharArray;
  THugeCharArray = array[0..0] of Char;

  T_Array = array[0..81] of Integer; {for Sorting} {mostly texture}
{Array4225 = Array[0..42,0..25]  of Byte;
Array8450 = Array[0..84,0..50]  of Byte; }
  AllClasses = array[0..9] of Byte; {For Histograms}
  Array9L = array[0..9] of LongInt;
  Array9I = array[0..9] of Integer;
  Array9D = array[0..9] of Double;
  Array20E = array[0..20] of Extended;
  Count = array[0..255] of LongInt;
  StatClasses = array[0..9, 0..9] of Byte;
  Array13I = array[1..13] of Integer;
  Array2020 = array[1..20, 1..20] of Byte;
{MyParity =TParity;}

  PrefRecord = record
  {This is my secret string ? as text?}
    PHiddenString: string[255]; {array [1..256] of Char;}
    PRPM_Program, PFilePath, PFilterPath,
    PRPM_DEM, PRPM_Vectors, PRPM_VDatabase, PRPM_Storage,
    PFractalDir,      PProLoaded: string[255];
    PMapBaseColor: Integer;
    PMapBordersColor, PMapGridsColor,
    PMapDatasColor, PMapBacksColor: TColor;
    PStarted: TDateTime;
    PStartedNameNumber: string[25];
    PRasterFormX, PRasterFormY,
      PREIVX, PREIVY,
      PColorFormX, PColorFormY,
      POptionsFormX, POptionsFormY,
      PPrintersizeFormX, PPrintersizeFormY,
      PResizeFormX, PResizeFormY,
      PSystemInfoFormX, PSystemInfoFormY,
      PImageInfoFormX, PImageInfoFormY,
      PViewCursorScreenX, PViewCursorScreenY,
      PRotateFormX, PRotateFormY,
      PMagniFormX, PMagniFormY,
      PPBandHdrFormX, PPBandHdrFormY,
      PPBHisX, PPBHisY,
      PLabelObjectsFormX, PLabelObjectsFormY,
      PObjectMarkFormX, PObjectMarkFormY,
      PPBandsX, PPBandsY,
      PHistogramFormX, PHistogramFormY,
      PFormPrintX, PFormPrintY,
      PFEditFormX, PFEditFormY,
      PFFTFormX, PFFTFormY,
      PClassificationFormX, PClassificationFormY,
      PLinearFormX, PLinearFormY,
      PLineProfileFormX, PLineProfileFormY,
      PDistanceFormX, PDistanceFormY,
      PPixelAlgebraFormX, PPixelAlgebraFormY,
      PMacroFormX, PMacroFormY,
      PVRLabFormX, PVRLabFormY,
      PMoxelFormX, PMoxelFormY,
      PVoxelFormX, PVoxelFormY,
      PPixelFormX, PPixelFormY,
      PAboutBoxX, PAboutBoxY: Integer;
    PColorRef, PColorWhite, PColorBlack, PCurrentColor,
      PColorPURPLE, PColorDPURPLE, PColorYELLOW, PColorLYELLOW,
      PColor1, PColor2, PColor3, PColor4, PColor5, PColor6, PColor8,
      PColor7, PColor9,
      PUVW, PVDW, PVMW, PVLW, PUDW, PUMW, PULW, PDDW, PDMW, PDLW,
      PMDW, PMMW, PMLW, PLDW, PLMW, PLLW,
      PUVC, PVDC, PVMC, PVLC, PUDC, PUMC, PULC, PDDC, PDMC, PDLC,
      PMDC, PMMC, PMLC, PLDC, PLMC, PLLC,
      PUVF, PVDF, PVMF, PVLF, PUDF, PUMF, PULF, PDDF, PDMF, PDLF,
      PMDF, PMMF, PMLF, PLDF, PLMF, PLLF,
      PUVA, PVDA, PVMA, PVLA, PUDA, PUMA, PULA, PDDA, PDMA, PDLA,
      PMDA, PMMA, PMLA, PLDA, PLMA, PLLA,
      PUVR, PVDR, PVMR, PVLR, PUDR, PUMR, PULR, PDDR, PDMR, PDLR,
      PMDR, PMMR, PMLR, PLDR, PLMR, PLLR,
      PUVT, PVDT, PVMT, PVLT, PUDT, PUMT, PULT, PDDT, PDMT, PDLT,
      PMDT, PMMT, PMLT, PLDT, PLMT, PLLT,
      PUVB, PVDB, PVMB, PVLB, PUDB, PUMB, PULB, PDDB, PDMB, PDLB,
      PMDB, PMMB, PMLB, PLDB, PLMB, PLLB,
      PUVU, PVDU, PVMU, PVLU, PUDU, PUMU, PULU, PDDU, PDMU, PDLU,
      PMDU, PMMU, PMLU, PLDU, PLMU, PLLU,
      PUVS, PVDS, PVMS, PVLS, PUDS, PUMS, PULS, PDDS, PDMS, PDLS,
      PMDS, PMMS, PMLS, PLDS, PLMS, PLLS
      : TColor;
{Menu}
    POpenWithPreview, PSaveWithPreview, PDisplayConvert32,
      PToggleOn, PDoneBeepOn, PVoicesOn, PBellsOn, PWhistlesOn,
      PErrorBeepOn, PErrorVoiceOn,
      PAutoRange, PBelowZero, PClipR, PDo_Ex_com,
      PV_Absolute, PR_AutoTT, PS_Threshold,
      PToggle_D_RGB, PToggle_D_R, PToggle_D_G, PToggle_D_B: Boolean;
    PbST_Min, PbST_Max: Byte; {0,255}
    PMessageX, PMessageY, PiAT_Min, PiAT_Max: Integer {0,255};
    PAll_Max, PAll_Min, PdAT_Max, PdAT_Min: Double;
  end;
  PrefFile = file of PrefRecord;


var
  PreRcd: PrefRecord;
  MapBaseColor: Integer;
  Started: TDateTime;
  HiddenString,
  StartedNameNumber: string;

  RasterFormX, RasterFormY,
    REIVX, REIVY,
    ColorFormX, ColorFormY,
    OptionsFormX, OptionsFormY,
    PrintersizeFormX, PrintersizeFormY,
    ResizeFormX, ResizeFormY,
    SystemInfoFormX, SystemInfoFormY,
    ImageInfoFormX, ImageInfoFormY,
    ViewCursorScreenX, ViewCursorScreenY,
    RotateFormX, RotateFormY,
    MagniFormX, MagniFormY,
    PBandHdrFormX, PBandHdrFormY,
    LabelObjectsFormX, LabelObjectsFormY,
    ObjectMarkFormX, ObjectMarkFormY,
    PBandsX, PBandsY,
    PBHisX, PBHisY,
    HistogramFormX, HistogramFormY,
    FormPrintX, FormPrintY,
    FEditFormX, FEditFormY,
    FFTFormX, FFTFormY,
    ClassificationFormX, ClassificationFormY,
    LinearFormX, LinearFormY,
    LineProfileFormX, LineProfileFormY,
    DistanceFormX, DistanceFormY,
    PixelAlgebraFormX, PixelAlgebraFormY,
    MacroFormX, MacroFormY,
    VRLabFormX, VRLabFormY,
    MoxelFormX, MoxelFormY,
    VoxelFormX, VoxelFormY,
    PixelFormX, PixelFormY,
    AboutBoxX, AboutBoxY: Integer;
    
  MyPixelFormat: TPixelFormat; {pf24bit pf32bit}
  PixelScanSize: Byte;

type
  StatsRecord = record
  SD, Variance:Double;
  Min,Max,Mean,Median,Mode,Sum,Num,Range:integer;
  CoVariance: Array of Double;
  JacobiEigenvalues:Double;
end;
var StatsArray: array of StatsRecord;  
var
{  Count = array[0..255] of LongInt;
  StatClasses = array[0..9, 0..9] of Byte;}
  RedStats, GreenStats, BlueStats: StatClasses;
  CountR, CountG, CountB, CountArray: Count;
  {  AllClasses = array[0..9] of Byte; }
  StatClassed, ClassesRGB, ClassesR, ClassesG, ClassesB: AllClasses;
    {Array8L;}
  StatsTextName, StatsArrayName, Stats3DName, CountName, Count3DName:
  string;
  ViewMagniOn, ViewCursorOnReally, DISisValid,
    bStartTraining, bTraining, ImageClassed,
    StatsFileExists, StatsTextFileExists, CountFailed,
    Stats3DFileExists, CountFileExists, Count3DFileExists: Boolean;

  B12CoVariance, B12R, B13CoVariance, B13R, B23CoVariance, B23R,
    RedSD, RedVariance, GreenSD, GreenVariance, BlueSD, BlueVariance:
  Double;


  SuperTChoice, MagnifierSize, PassRange,
RedMin,RedMax,RedMean,RedMedian,RedMode,RSum,RNum,RedRange,
GreenMin,GreenMax,GreenMean,GreenMedian,GreenMode,GSum,GNum,GreenRange,
BlueMin,BlueMax,BlueMean,BlueMedian,BlueMode,BSum,BNum,BlueRange: Integer;

 {Parity,MyParity:TParity;  }{pOdd}{ Open:Boolean;}
{Digitizer}{
RD_Stream,RD_Reset,RD_Start,RD_Stop,
DigitizerID, UserDigitizerID,
RD_Increment0,RD_Increment1,RD_Increment2,RD_Increment3,RD_Increment4,
RD_Increment5,RD_Increment10,RD_Increment15,RD_Increment25,RD_Increment35,
RD_Increment55,RD_Increment95,RD_IncrementA,RD_IncrementB,RD_IncrementC,
RD_Resolution1000,RD_Resolution500,RD_Resolution400,RD_Resolution200,
RD_Resolution100,RD_Resolution4,RD_Resolution2,RD_Resolution1,
RD_Resolution40lpmm,RD_Resolution20lpmm,RD_Resolution10lpmm,
RD_ReportRate110,RD_ReportRate50,RD_ReportRate10,RD_ReportRate2,
CommNumber,Baud,DataBits,StopBits,TriggerLength,
RD_IncrementCode,RD_IncrementDef,RD_ResolutionDef,RD_ReportRateDef,
RD_Test,RD_Echo,RD_ModelID,RD_CodeCheck,RD_CheckConfig,RD_SendTest,}
  UserID: Integer;
{DigitizerName,}{Directories}
  KBFileName, CLayerFileName, NNFileName, CAMFileName,
    BandFile1, BandFile2, BandFile3,
    BandFile4, BandFile5, BandFile6L,
    BandFile6H, BandFile7, BandFile8,
    BandFileSaveAsStr, BandHeader,
    TSFileName, OMFileName, LOFileName,
    FEFilename, FExt, GRIPFileName: string;
    RPM_Program, ImagePath, RPM_DEM, RPM_Vectors,
    FilterPath, RPM_VDatabase, RPM_Storage: string;
{Toggles for RPM: Raster Preferences Memory}
{bPointMode, bLineMode,bPolyMode, bStreamMode,RD_Ascii,}

FormControl:Integer;
{Form control}
  REIVFormActive, SystemInfoFormActive, FrInfoActive,
  PrintersizeFormActive,
  HistogramFormActive,
  LinearFormActive, {Distance} LineProfileFormActive,
  LabelObjectsFormActive, ObjectMarkFormActive,
  PixelAlgebraFormActive,  FFTFormActive,
  FEditFormActive, ClassificationFormActive,
  PBandHdrFormActive,
  DisProcessFormActive {from PBands},
{Menu}
  OpenWithPreview, SaveWithPreview, DisplayConvert32, ToggleOn,
    ErrorBeepOn, ErrorVoiceOn, DoneBeepOn, VoicesOn, BellsOn,
    WhistlesOn,

  ClipR, Do_Ex_com, BelowZero, AutoRange,
    V_Absolute, R_AutoTT, S_Threshold,
    Toggle_D_RGB, Toggle_D_R, Toggle_D_G, Toggle_D_B: Boolean;

  bST_Min, bST_Max: Byte; {0,255}
  iAT_Min, iAT_Max: Integer; {0,255}
  All_Max, All_Min, dAT_Max, dAT_Min: Double;
  MessageX, MessageY,
  BandsAvailable, LeftColumn, RightColumn, TopRow, BottomRow: Integer; {Image.idx}

  ClassifiedArray: array of ClassifiedRecord;
  ObjectMarkerArray: array of ObjectMarker;
  ObjectLabelArray: array of ObjectLabel;
  pointStart: TPoint; {MOUSING}
  pointEnd: TPoint;
{  CurrentLabel,  LabelListCount:Integer;}
      WandingOn, Processing:Boolean;{Linear}

  ObjectMarking, ObjectMarkingOn,
    ObjectLabeling, ObjectLabelingOn,
    MouseLocatext,
    bRightDown, bLeftDown, Drawing, StartDrawing, StartSnake,
    ProfileDrawing, Profiling, ProfileLineDrawing,
    StartCropping, Cropping,
    StartCropping256, CropTo_256,
    StartCropping512, CropTo_512,
    StartCropping1024, CropTo_1024,
    DO_RGBRotate, DO_RGBNegRotate,
    MakeBitmapRotate, DeleteBitmapRotate, Toggle_D_Rotate,
    LoggingToDIP, LoggingToMacro, PlayingMacro,
    ViewCursorOn, NotYetShown,
    DoingBigTimeRegistration,
    Image_Add, Image_Subtract, ImageMade, ImageLoaded,
    MyChanged, IsModified, bCMYK: Boolean;

  TextureHeight, TextureSize,
    ViewX1, ViewX2, ViewY1, ViewY2, ThingToDo: Word;
  HisHigh, HisWide,
    WhichS, InBand, BandSelected,
    Counter, PixelLine, InDistance, HowMany, Per_Done: Integer;

  BytesPerLine, ImageHeight, ImageWidth, InfoSize, ImageSize,
  WherePixel,  hRedBitmap, hGreenBitmap, hBlueBitmap,
  Undoh, Workh, Imageh:  DWord;

  pRedBitmapInfo, pGreenBitmapInfo, pBlueBitmapInfo,
  pUndoInfo, pWorkInfo, pImageInfo: PBitmapInfo;

  RedBitmap, GreenBitmap, BlueBitmap, Undo, Work, Image: Pointer;

  pPixelB, pPixelG, pPixelR,
   lpPixelB, lpPixelG, lpPixelR, lpPixelTR: ^Byte;

  ColorRef, ColorWhite, ColorBlack, CurrentColor,
    ColorPURPLE, ColorDPURPLE, ColorYELLOW, ColorLYELLOW,
    Color1, Color2, Color3, Color4, Color5, Color6, Color8, Color7,
    Color9,
    UVW, VDW, VMW, VLW, UDW, UMW, ULW, DDW, DMW, DLW, MDW, MMW, MLW,
    LDW, LMW, LLW,
    UVC, VDC, VMC, VLC, UDC, UMC, ULC, DDC, DMC, DLC, MDC, MMC, MLC,
    LDC, LMC, LLC,
    UVF, VDF, VMF, VLF, UDF, UMF, ULF, DDF, DMF, DLF, MDF, MMF, MLF,
    LDF, LMF, LLF,
    UVA, VDA, VMA, VLA, UDA, UMA, ULA, DDA, DMA, DLA, MDA, MMA, MLA,
    LDA, LMA, LLA,
    UVR, VDR, VMR, VLR, UDR, UMR, ULR, DDR, DMR, DLR, MDR, MMR, MLR,
    LDR, LMR, LLR,
    UVT, VDT, VMT, VLT, UDT, UMT, ULT, DDT, DMT, DLT, MDT, MMT, MLT,
    LDT, LMT, LLT,
    UVB, VDB, VMB, VLB, UDB, UMB, ULB, DDB, DMB, DLB, MDB, MMB, MLB,
    LDB, LMB, LLB,
    UVU, VDU, VMU, VLU, UDU, UMU, ULU, DDU, DMU, DLU, MDU, MMU, MLU,
    LDU, LMU, LLU,
    UVS, VDS, VMS, VLS, UDS, UMS, ULS, DDS, DMS, DLS, MDS, MMS, MLS,
    LDS, LMS, LLS
    : TColor;


  ChangeUnitsLL,SkipXYtoLL:Boolean;
  MapRes,  ToDDegreeFactorLL,UnitFactorLL:Double;
  MapProjSys,   {MapTestFlag,}MapZone,
  MapUnits,  DigitizerUnits,  MapScale, MapDatum:Integer;

Type
  DIHRec=Record
  {MapData page}
    RIHIDEdit:String[7];
    RIHHeaderFileEdit, RIHRIHEdit, RIHSceneTitle,
    RIHLC, RIHRC, RIHIW, RIHinLine, RIHTR, RIHBR, RIHIH, RIHinColumn,
    RIHSensorType, RIHSensorID, RIHRecordSizeEdit,
    RIHPath, RIHStartRow, RIHEndRow, RIHBlockEdit,
    RIHAcquiredEdit, RIHProducedEdit, RIHProductSizeEdit,
    RIHProjectRollFrameEdit, RIHVolumeEdit, RIHinSetEdit,
    RIHImageTypeEdit,
    RIHSensorModeEdit, RIHDataSource, RIHProjectData,
    RIHLookAngleEdit, RIHDirectionEdit, RIHSourceScale,
    RIHOffsetEdit, RIHRangeEdit, RIHScannedRez,
    SensorAltitudeEdit, RIHOrientationAngleEdit,
      RIHAcquiredBitsEdit, RIHCurrentBitsEdit,
    RIHSwathWidthEdit, RIHSwathWidthRezEdit,
      RIHSwathHeightEdit, RIHSwathHeightRezEdit,  RIHFlightlineEdit,
    RIHWeatherEdit, PercentCloudsEdit,
      RIHSunAzimuthAngleEdit, RIHSunElevationAngleEdit
    :String[255];

  {Bands}
     RIHNBEdit, RevEdit, SignalEdit, PolarityEdit  :String[7];
     RIHBFName1,RIHBFName2,RIHBFName3,RIHBFName4,RIHBFName5,
     RIHBFName6H,RIHBFName6L,RIHBFName7,RIHBFName8:String[255];
     RIHBName1, RIHBSR1,  RIHGain1,RIHBias1,
     RIHBName2, RIHBSR2,  RIHGain2,RIHBias2,
     RIHBName3, RIHBSR3,  RIHGain3,RIHBias3,
     RIHBName4, RIHBSR4,  RIHGain4,RIHBias4,
     RIHBName5, RIHBSR5,  RIHGain5,RIHBias5,
     RIHBName6L, RIHBSR6L,  RIHGain6L,RIHBias6L,
     RIHBName6H, RIHBSR6H,  RIHGain6H,RIHBias6H,
     RIHBName7, RIHBSR7,  RIHGain7,RIHBias7,
     RIHBName8, RIHBSR8,  RIHGain8,RIHBias8  :String[19];
     RIHMin1, RIHMax1,       RIHMin2, RIHMax2,       RIHMin3, RIHMax3,
     RIHMin4, RIHMax4,       RIHMin5, RIHMax5,       RIHMin6L, RIHMax6L,
     RIHMin6H, RIHMax6H,     RIHMin7, RIHMax7,       RIHMin8, RIHMax8
     :String[19];

  {GeoData}
    ImageLatLongorUTMEdit:string[40];
    ProjectionCBIn, UnitCBIn, UtmZoneCBIn, DatumCBIn, SpheroidCBIn:Integer;
    XShiftEdit, YShiftEdit,
    XUnitsCB, YUnitsCB, ZUnitsCB, MUnitsCB:Integer;
    MapXMaxEdit,MapXMinEdit,
    MapYMaxEdit,MapYMinEdit,
    MapZMaxEdit,MapZMinEdit,
    MapMMaxEdit,MapMMinEdit:Double;
    ProjectionGridOriginEdit,GridOriginXEdit,GridOriginYEdit,
    DDDMSGridUnitEdit, PixelXSizeEdit, PixelYSizeEdit,
    ColumnXEdit, RowsYEdit,
    ImageCellOriginEdit, CellOriginXEdit, CellOriginYEdit,
    LeftX1Edit, TopY1Edit, RightX2Edit, BottomY2Edit
    :string[40];
  {MapData page}
    MapNameEdit, MapQuadrangleEdit:string[40];
    MapDateEdit:string[10];
    MapRevisionEdit:string[1];
    CatNameCB:Integer;  {Checkbox}
    MapScaleEdit:string[8];
    SubQuadEdit:string[2];
    ProductTypeEdit, PreProcessingEdit,
    ResamplingTechniqueEdit :string[40];
    MetadataFileEdit:string[255];

  {Proj in}
    bProjectionValidCBox, bNeverProjectedCB, bIsProjectedCB :Boolean;
    A1Edit,A2Edit,A3Edit,
    B1Edit,B2Edit,B3Edit,
    C1Edit,C2Edit,C3Edit,
    D1Edit,D2Edit,D3Edit,
    E1Edit,E2Edit,E3Edit,
    DLGPP1,DLGPP2,DLGPP3,DLGPP4,
    DLGPPP1,DLGPPP2,DLGPPP3,DLGPPP4,
    DLGPPP5,DLGPPP6,DLGPPP7,DLGPPP8:Double;

  {Proj out Out}
    ProjectionCBOut,
    UnitCBOut,
    UtmZoneCBOut,
    DatumCBOut,
    SpheroidCBOut,
    StatePlaneZoneEditOut:Integer;
    bIgnoreDatumCB, bIgnoreErrorsCB,
    bUTMZoneNorthCB:Boolean;
                {StrToFloatDef}
    ModeEdit,
    SMajorEdit, SMinorEdit,    SphereEdit,
    FEEdit,     FNEdit,        OriginLatEdit,
    STDPR1Edit, STDPR2Edit,    CentMerEdit,
    TrueScaleEdit,    CentLonEdit,    CenterLatEdit,
    STDPAREdit, LongPolEdit, FactorEdit, HeightEdit,
    ShapeMEdit, ShapeNEdit,  AngleEdit,
    Long1Edit,  Long2Edit,   Lat1Edit,   Lat2Edit,
    AziAngEdit, AzmthPtEdit, IncAngEdit,
    AscLongEdit,PSRevEdit,   LRatEdit,
    PFlagEdit,  SatnumEdit,  PathEdit:Double;
    DLGPA1,DLGPA2,DLGPA3,
    DLGPB1,DLGPB2,DLGPB3,
    DLGPC1,DLGPC2,DLGPC3,
    DLGPD1,DLGPD2,DLGPD3,
    DLGPE1,DLGPE2,DLGPE3:Double;

  {Extent}
    bCoordinatesValidCBox:Boolean;
    ULLongitudeEdit,ULLatitudeEdit,
    URLongitudeEdit, URLatitudeEdit,
    LLLongitudeEdit,LLLatitudeEdit,
    LRLongitudeEdit,LRLatitudeEdit,
    CenLongitudeEdit,CenLatitudeEdit    :Double;
    ULCoXEdit,ULCoYEdit, URCoXEdit, URCoYEdit,
    LLCoXEdit, LLCoYEdit, LRCoXEdit, LRCoYEdit,
    CenCoXEdit, CenCoYEdit, CenCoPixXEdit, CenCoPixYEdit:Integer;
  {Registration Data}
    bRegistrationValidCBox: Boolean;
    RegistrationPointsCountEdit:Integer;
    {Registration Array of DATA... ???}

  {CoLocated TS}
    CoLocatedDataCBox, OverlappedCoverageCBox,
    StereoCoverageCBox : Boolean;
    MapEdge1Edit, MapEdge2Edit, MapEdge3Edit, MapEdge4Edit,
    MapEdgeW1Edit,MapEdgeW2Edit,
    MapEdgeN1Edit,MapEdgeN2Edit,
    MapEdgeE1Edit,MapEdgeE2Edit,
    MapEdgeS1Edit,MapEdgeS2Edit:Char;
    RIHNECoFileEdit, RIHNCoFileEdit, RIHNWCoFileEdit, RIHECoFileEdit,
    RIHWCoFileEdit, RIHSECoFileEdit, RIHSCoFileEdit, RIHSWCoFileEdit
    :string[255];
  {DIS s  a lotta strings.........}
  end;
var   MapProject{DIHHeader}: DIHRec;
type
  RegRecord = record
    RegX, RegY: Integer;
    RegLatitude, RegLongitude: Double;
  end;
var RegArray:Array of RegRecord;
  MMSysHandle: THandle;
  PlaySound: function(lpszSoundName: PAnsiChar; uFlags: UINT): BOOL;
  stdcall;

function ExecuteFile(const FileName, Params, DefaultDir: string;  ShowCmd: Integer): THandle;
function MinW(a, b: Word): Word;
function MaxW(a, b: Word): Word;
function Mini(a, b: Integer): Integer;
function Maxi(a, b: Integer): Integer;
{procedure ChangeName(a,b:Char);}
procedure NumberName;
procedure SetFileName(InFileName: string);
procedure Codefx(WhatString: string; Codein: Integer);
procedure DoMessages(i: Integer);
procedure Set3D_Done(Step, i_Per_Done: Integer);
procedure SetP_Done1(i_Per_Done: Integer);
procedure SetP_Done(iStage, iPer_Done: Integer; dAll_Min, dAll_Max:  Double);
procedure myLoadImage;
procedure MakeImage;
procedure FreeImage;
procedure UnLoadImage;
procedure Do_Change(WhatColor: Integer);
procedure BlackOut;
procedure SetImage;
procedure UndoImage;
procedure Do_MakeBitmapRotate;
procedure Do_DeleteBitmapRotate;
procedure Do_TheRotate;
function WhatsMySize(FFileName: string): Integer;
procedure DoLoader;
procedure SetPreferences;
procedure DoSaver;
procedure GetPreferences;
function StrToFloatDef(InString:String;InDefault:Double):Double;
implementation

uses gGrip, gAbout;

var
  hBmR, hBmG, hBmB: HBitmap;
  BmR, BmG, BmB: TBitmap;
{---------------------------------------------------------------------}
{StrToFloatDef(ModeEdit.Text,0)}
function StrToFloatDef(InString:String;InDefault:Double):Double;
var
  Code:Integer;
  Defaultoid:Double;
Begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  Val(InString, Defaultoid, Code);
  if Code <> 0 then Result:=InDefault else Result:=Defaultoid;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
End;
function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;

function MinW(a, b: Word): Word;
begin
  if a < b then MinW := a
  else MinW := b;
end;

function MaxW(a, b: Word): Word;
begin
  if a > b then MaxW := a
  else MaxW := b;
end;

function Mini(a, b: Integer): Integer;
begin
  if a < b then Mini := a
  else Mini := b;
end;

function Maxi(a, b: Integer): Integer;
begin
  if a > b then Maxi := a
  else Maxi := b;
end;
{---------------------------------------------------------------------}
{This changes the FILENAME.PCX to FILENA01.PCX}
{The other idea was to use characters,
 FILEX01X.PCX but they miss the boat}
 (*ChangeName('K', 'Y');*)
{PLAN to use the input characters to record the type of
file manipulation into a LOG file of IP activity}

procedure NumberName;
(*ChangeName(a,b:Char);*)
var
  FileExists: boolean;
  fsave: file of byte;
  I {,NameNumber,Code }: Integer;
{Keeper:Char;}
{NString:String[1];}
  Temps: string;
  FileLen: Word;
var MySet: set of 'a'..'z';
begin
  MySet := ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'];
  FileLen := Length(GRIPFileName);
  If (FileLen < 8) or
     (GRIPFileName[Length(GRIPFileName) - 8] <> 'A') then
  begin                   {A000.png}
    Temps := ExtractFileExt(GRIPFileName);
    GRIPFileName[Length(GRIPFileName) - 3] := 'A';
    GRIPFileName[Length(GRIPFileName) - 2] := '0';
    GRIPFileName[Length(GRIPFileName) - 1] := '0';
    GRIPFileName[Length(GRIPFileName)] := '0';
    GRIPFileName := GRIPFileName + Temps;
  end;
  I := FileLen - 1;
  while (I <> 0) and ((GRIPFileName[I] <> '.')) do Dec(I);
   {Dec's while looking, Dec again to get to right place}
  Dec(I);
  if GRIPFileName[I] in MySet then GRIPFileName[I] := char($30);
  if GRIPFileName[I - 1] in MySet then GRIPFileName[I - 1] := char($30);
  if GRIPFileName[I - 2] in MySet then GRIPFileName[I - 2] := char($30);
  begin
    inc(GRIPFileName[I]);
        { $3A is :, the Char after 9}
    if GRIPFileName[I] >= char($3A) then
    begin
      if GRIPFileName[I - 1] >= char($3A) then
      begin
        GRIPFileName[I - 1] := char($30); { $30 is 0 }
        inc(GRIPFileName[(I - 2)]);
      end;
      GRIPFileName[I] := char($30); { $30 is 0 }
      inc(GRIPFileName[(I - 1)]);
    end;
  end;
{The file has already been incremented,
this checks to see if there is already a file with that number
and if so it increments the file number until it can be saved
or the file number reaches 999}
  repeat;
{$I-}
    Assign(fsave, ImagePath + GRIPFileName);
    Reset(fsave);
    Close(fsave);
{$I+}
    FileExists := (IOResult = 0);
    if FileExists then
    begin
      inc(GRIPFileName[I]); { $39 = 9 }
      if GRIPFileName[I] > char($39) then
      begin
        if GRIPFileName[I - 1] > char($39) then
        begin
          GRIPFileName[I - 1] := char($30); { $30 = 0 }
          inc(GRIPFileName[(I - 2)]);
        end;
        GRIPFileName[I] := char($30); { $30 = 0 }
        inc(GRIPFileName[(I - 1)]);
      end;
    end; { $39 = 9 }
  until (not FileExists) or
    ((GRIPFileName[(I)] = char($39))
    and (GRIPFileName[(I - 1)] = char($39))
    and (GRIPFileName[(I - 2)] = char($39)));
  SetFileName(GRIPFileName);
  if ((GRIPFileName[(I)] = char($39))
    and (GRIPFileName[(I - 1)] = char($39))
    and (GRIPFileName[(I - 2)] = char($39))) then
    DoMessages(39983); {Filename has reached 999}
end;
{--------------------------------------------------}
{---------------------------------------------------------------------}
(*PROCEDURE NumberName;
VAR
FileExists : boolean;
fsave : FILE of byte;
I{,NameNumber,Code} : Integer;
{Keeper:Char;}
{NString:String[1];}
FileLen :Word;
var MySet: set of 'a'..'z';
BEGIN
MySet := ['0','1','2','3','4','5','6','7','8','9'];
  FileLen := Length(FileName);
  I := FileLen - 1;
  while (I <> 0) and ( (FileName[I] <> '.')) do Dec(I);
   {Dec's while looking, Dec again to get to right place}
    Dec(I,1);
    if {'a'}FileName[I] in MySet then FileName[I] := char($30);
{Checks to see if a number not what number... compiler complains
    val(FileName[I],NameNumber,Code);
    If Code <> 0 then 	FileName[I] := char($30);}

    if {'a'}FileName[I-1] in MySet then FileName[I-1] := char($30);
{Checks to see if a number not what number... compiler complains
    val(FileName[(I-1)],NameNumber,Code);
    If Code <> 0 then 	FileName[(I-1)] := char($30);}
    Repeat;
    {$I-}
    Assign(fsave,FilePath+FileName);
    Reset(fsave);
    Close(fsave);
    {$I+}
    FileExists := (IOResult = 0);
    if FileExists then
       begin
          inc(FileName[I]);
          { $3A is :, the Char after 9}
        if FileName[I] >= char($3A) then
 begin
 FileName[I] := char($30);
 { $30 = 0 }
 inc(FileName[(I-1)]);
 end;
      end;                           { $39 = 9 }
    until (not FileExists) or (FileName[(I-1)] > char($39));
SetFileName(FileName);
End;*)

procedure SetFileName(InFileName: string);
begin
  GRIPFileName := InFileName;
  GRIPForm.Caption := 'GRIP ICE' + '  Image is: ' + GRIPFileName;
end;
{---------------------------------------------------------------------}

procedure Codefx(WhatString: string; Codein: Integer);
{var CodeS:String;}
begin
  if Codein <> 0 then begin
{str(Codein,CodeS);}
{ShowMessage('Error in File data Number: '+#13#10+
                CodeS+#13#10+
                WhatString); }
    MessageDlgPos(
      'Error in File data Number: '
      + #13#10 + IntToStr(Codein)
      + #13#10 + WhatString,
      mtError,
      [mbOK], {mbYesNoCancel,}
      0,
      MessageX,
      MessageY);
  end;
end;


procedure Set3D_Done(Step, i_Per_Done: Integer);
var S_Done: string;
begin
  GRIPForm.Gauge1.Progress := i_Per_Done;
  Str(i_Per_Done, S_Done);
  case Step of
    1: GRIPForm.StatusBar1.Panels[0].Text :=
      'Making Array (1/4) % Done: ' + S_Done;
    2: GRIPForm.StatusBar1.Panels[0].Text :=
      'Counting Image (2/4) % Done: ' + S_Done;
    3: GRIPForm.StatusBar1.Panels[0].Text :=
      'Saving Count (3&4/4) % Done: ' + S_Done;
    4: GRIPForm.StatusBar1.Panels[0].Text :=
      'Displaying Count (4/4) % Done: ' + S_Done;
    5: GRIPForm.StatusBar1.Panels[0].Text :=
      'Loading Count (2&3&4) % Done: ' + S_Done;
  end;
  Application.ProcessMessages;
end;

procedure SetP_Done1(i_Per_Done: Integer);
var S_Done: string;
begin
  GRIPForm.Gauge1.Progress := i_Per_Done;
  Str(i_Per_Done, S_Done);
  GRIPForm.StatusBar1.Panels[0].Text := '(Part 1 of 1) % Done: ' +
    S_Done;
  Application.ProcessMessages;
end;

procedure SetP_Done(iStage, iPer_Done: Integer; dAll_Min, dAll_Max:
  Double);
var S_Done, SMax, SMin: string;
begin
  GRIPForm.Gauge1.Progress := iPer_Done;
  {The first has to use StrCopy, the rest use StrCat}
  if (iStage = 1) then begin
    Str(iPer_Done, S_Done);
    S_Done := '(Part 1 of 2) % Done:  ' + S_Done;
  end else
    if (iStage = 2) then begin
      Str(iPer_Done, S_Done);
      S_Done := '(Part 2 of 2) % Done:  ' + S_Done;
    end;
  Str(dAll_Min: 5: 2, SMin);
  Str(dAll_Max: 5: 2, SMax);
  S_Done := S_Done + ' Min: ' + SMin + ' Max:' + SMax;
  GRIPForm.StatusBar1.Panels[0].Text := S_Done;
  Application.ProcessMessages;
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure myLoadImage;
var
  temp: DWord;
  dc: HDC;
begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  Screen.Cursor := CRHOURGLASS;
{RasterForm.Cursor := 1;}
  if (GRIPForm.Image1.Picture.Graphic <> nil) then
  begin
    dc := GetDc(0);
    if (GetDeviceCaps(dc, BITSPIXEL) >= 24) then
    begin
    {  dc :=} ReleaseDc(0, dc);
    {Give back the screen dc ... compiler complains}
    {pf24bit, pf32bit}
      if (GRIPForm.Image1.Picture.Bitmap.PixelFormat = pf24bit) then
      begin
        GetDIBSizes(GRIPForm.Image1.Picture.Bitmap.Handle,
          InfoSize, ImageSize);
        ImageLoaded := False;
        try
          ImageWidth := GRIPForm.Image1.Picture.Bitmap.Width - 1;
          ImageHeight := GRIPForm.Image1.Picture.Bitmap.Height - 1;
          temp := trunc(((GRIPForm.Image1.Picture.Bitmap.Width * 24)
                          + 31) / 32);
          BytesPerLine := (temp * 4);
          pImageInfo := AllocMem(InfoSize);
          Imageh := GlobalAlloc(GMEM_MOVEABLE, ImageSize);
          if Imageh > 0 then ImageLoaded := True else
          begin
            DoMessages(40000);
            Application.Terminate;
          end;
          pUndoInfo := AllocMem(InfoSize);
          Undoh := GlobalAlloc(GMEM_MOVEABLE, ImageSize);
          if Undoh > 0 then ImageLoaded := True else
          begin
            DoMessages(40000);
            Application.Terminate;
          end;
          GRIPForm.StatusBar1.Panels[0].Text := 'Image loaded';
          Application.ProcessMessages;
        finally {Free up the memory we used}
          if (not ImageLoaded) then FreeImage;
        end;
      end else DoMessages(12); {not a 24 bit image}
    end else
    begin
      DoMessages(11);
    {dc :=} ReleaseDc(0, dc);
      {Give back the screen dc ... compiler complains}
    end; {of if 24 bit}
  end {of if a picture}
  else DoMessages(10);
  Screen.Cursor := CRDEFAULT;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
end; {of this}
{---------------------------------------------------------------------}

procedure MakeImage;
{var}
{temp:DWord;}
{dc : HDC;}
begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  Screen.Cursor := CRHOURGLASS;
  try
    ImageMade := False;
    if Imageh > 0 then begin
      Image := GlobalLock(Imageh);
      ImageMade := True;
    end else
    begin
      DoMessages(39977);
      exit;
    end;
    if Undoh > 0 then begin
      Undo := GlobalLock(Undoh);
      ImageMade := True;
      GRIPForm.UndoBtn.Enabled := True;
      GRIPForm.I_Undo.Enabled := True;
    end else
    begin
      DoMessages(39977);
      exit;
    end;
(* The UNDO remains a copy of the original... not of the latest process*)
    GetDIB(GRIPForm.Image1.Picture.Bitmap.Handle,
      GRIPForm.Image1.Picture.Bitmap.Palette, pUndoInfo^, Undo^);
    GetDIB(GRIPForm.Image1.Picture.Bitmap.Handle,
      GRIPForm.Image1.Picture.Bitmap.Palette, pImageInfo^, Image^);
    GRIPForm.StatusBar1.Panels[1].Text :=
      'Image copied for processing';
    Application.ProcessMessages;
  finally {Free up the memory we used}
    if (not ImageMade) then FreeImage;
  end;
  Screen.Cursor := CRDEFAULT;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
end; {of this}
{---------------------------------------------------------------------}

procedure FreeImage;
begin
  GlobalUnlock(Imageh);
  GlobalUnlock(Undoh);
end;

procedure UnLoadImage;
begin
  FreeImage;
  GlobalFree(Imageh);
  FreeMem(pImageInfo, InfoSize);
  GlobalFree(Undoh);
  FreeMem(pUndoInfo, InfoSize);
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure BlackOut;
var IL, IW: DWord;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
begin
{Called AFTER HowMany has been initiated}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
{TOP}
  for IL := 0 to ILStart do
    for IW := 0 to ImageWidth do
     {   SetPixel(hWorkDC, IW, IL,ColorBlack); }
      WherePixel := ((IW * 3) + (IL * BytesPerLine));
  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
  lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
  lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
  lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 0;

{Bottom}
  for IL := (ILEnd - 1) to ImageHeight do
    for IW := 0 to ImageWidth do
{        SetPixel(hWorkDC, IW, IL,ColorBlack);}
      WherePixel := ((IW * 3) + (IL * BytesPerLine));
  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
  lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
  lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
  lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 0;

{Left}
  for IL := 0 to ImageHeight do
    for IW := 0 to IWStart do
{        SetPixel(hWorkDC, IW, IL,ColorBlack);  }
      WherePixel := ((IW * 3) + (IL * BytesPerLine));
  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
  lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
  lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
  lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 0;

{Right}
  for IL := 0 to ImageHeight do
    for IW := (IWEnd - 1) to ImageWidth do
{        SetPixel(hWorkDC, IW, IL,ColorBlack);}
      WherePixel := ((IW * 3) + (IL * BytesPerLine));
  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
  lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
  lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
  lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 0;

end; {of BlackOut}

{---------------------------------------------------------------------}

procedure SetImage;
var
  hBm: HBitmap;
  Bm: TBitmap;
  dc: HDC;
  s: array[0..79] of char;
{hOldPal   : HPalette;}
begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  Screen.Cursor := CRHOURGLASS;
  dc := GetDc(0);
  hBm := CreateDiBitmap(dc,
                        pImageInfo^.bmiHeader,
                        CBM_INIT,
                        pChar(Image),
                        pImageInfo^,
                        DIB_RGB_COLORS);
{  dc :=} ReleaseDc(0, dc); {Give back the screen dc}
  {Give back the screen dc ... compiler complains}
  bm := TBitmap.Create; {Create a temporary TBitmap}
  bm.PixelFormat := pf24bit;
  FreeImage;
  bm.Handle := hBm; {Assign the handle}
  GRIPForm.Image1.Picture.Bitmap := bm; {Assign the bitmap}
  GRIPForm.Image1.Picture.Bitmap.PixelFormat := pf24bit;
  SelectPalette(GRIPForm.Image1.Picture.Bitmap.Canvas.Handle,
                GRIPForm.Image1.Picture.Bitmap.Palette,
                false);
  bm.free;
  Screen.Cursor := CRDEFAULT;
  GRIPForm.StatusBar1.Panels[1].Text := 'Image processed';
  Application.ProcessMessages;
  GRIPForm.Gauge1.Progress := 0;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}

  if (DoneBeepOn) then begin
    if (VoicesOn) then begin
      StrPCopy(s, 'DONEV.WAV');
      if (MMSysHandle <> 0) then PlaySound(s, {SND_ASYNC} 0);
{        sndPlaySoundA(s, 0);}
    end else
      if (BellsOn) then begin
        StrPCopy(s, 'DONEB.WAV');
{        sndPlaySoundA(s, 0);}
        if (MMSysHandle <> 0) then PlaySound(s, {SND_ASYNC} 0);
      end;
    if (WhistlesOn) then begin
      StrPCopy(s, 'DONEW.WAV');
{        sndPlaySoundA(s, 0);}
      if (MMSysHandle <> 0) then PlaySound(s, {SND_ASYNC} 0);
    end;
  end;
end; {of this}
{---------------------------------------------------------------------}
(*      Begin
StrPCopy(s, 'DONE.WAV');
{Play the sound asynchronously}
sndPlaySound(s, 0); {see mmsystem.hlp for other values}
{
If you specify the SND_MEMORY flag, lpszSoundName must point to an
in-memory image of a waveform sound.
If the sound is stored as a resource, use
LoadResource and LockResource to load and lock the resource and get a
pointer to it.
}
       {setimage calls the ImageDone}
       {Whistle is a for i:= 100 do
       go up then down then around }
               { Beep( Pitch, Duration );}
{      Beep(1000,100);}{Order of units must make difference?}
      end;*)
{---------------------------------------------------------------------}

procedure UndoImage;
var
  hBm: HBitmap;
  Bm: TBitmap;
  dc: HDC;
{hOldPal   : HPalette;}
begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  Screen.Cursor := CRHOURGLASS;
  dc := GetDc(0);
  hBm := CreateDiBitmap(dc,
                        pUndoInfo^.bmiHeader,
                        CBM_INIT,
                        pChar(Undo),
                        pUndoInfo^,
                        DIB_RGB_COLORS);
{  dc :=} ReleaseDc(0, dc); {Give back the screen dc}
  {Give back the screen dc ... compiler complains}
  bm := TBitmap.Create; {Create a temporary TBitmap}
  bm.PixelFormat := pf24bit;
  FreeImage;
  bm.Handle := hBm; {Assign the handle}
  GRIPForm.Image1.Picture.Bitmap := bm; {Assign the bitmap}
  GRIPForm.Image1.Picture.Bitmap.PixelFormat := pf24bit;
  SelectPalette(GRIPForm.Image1.Picture.Bitmap.Canvas.Handle,
                GRIPForm.Image1.Picture.Bitmap.Palette,
                false);
  GRIPForm.UndoBtn.Enabled := False;
  GRIPForm.I_Undo.Enabled := False;
  Screen.Cursor := CRDEFAULT;
  GRIPForm.StatusBar1.Panels[1].Text := 'Image Undone';
  Application.ProcessMessages;
  GRIPForm.Gauge1.Progress := 0;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
end; {of this}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure Do_MakeBitmapRotate;
var
  IL, IW, temp: DWord;
  dc: HDC;
  CMY, RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
{Range,FLength, FWidth,ErrorPos,   sX, sY,  Where : Integer;}
begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  MakeBitmapRotate := False;
  Screen.Cursor := CRHOURGLASS;
  if (GRIPForm.Image1.Picture.Graphic <> nil) then begin
    dc := GetDc(0);
    if (GetDeviceCaps(dc, BITSPIXEL) >= 24) then begin
 {  dc :=} ReleaseDc(0, dc); {Give back the screen dc}
  {Give back the screen dc ... compiler complains}
{  pf24bit, pf32bit}
      if (GRIPForm.Image1.Picture.Bitmap.PixelFormat = pf24bit) then
      begin
        GetDIBSizes(GRIPForm.Image1.Picture.Bitmap.Handle,
                    InfoSize, ImageSize);
        try
          MakeImage;
          pRedBitmapInfo := AllocMem(InfoSize);
          hRedBitmap := GlobalAlloc(GMEM_MOVEABLE, ImageSize);
          if hRedBitmap > 0 then MakeBitmapRotate := True else
          begin MakeBitmapRotate := False;
            DoMessages(39977);
            exit;
          end;
          RedBitmap := GlobalLock(hRedBitmap);
          GetDIB(GRIPForm.Image1.Picture.Bitmap.Handle,
                 GRIPForm.Image1.Picture.Bitmap.Palette,
                 pRedBitmapInfo^,
                 RedBitmap^);
          GRIPForm.StatusBar1.Panels[1].Text := 'Rotate Red loaded';
          Application.ProcessMessages;

          pGreenBitmapInfo := AllocMem(InfoSize);
          hGreenBitmap := GlobalAlloc(GMEM_MOVEABLE, ImageSize);
          if hGreenBitmap > 0 then MakeBitmapRotate := True else
          begin MakeBitmapRotate := False;
            DoMessages(39977);
            exit;
          end;
          GreenBitmap := GlobalLock(hGreenBitmap);
          GetDIB(GRIPForm.Image1.Picture.Bitmap.Handle,
                 GRIPForm.Image1.Picture.Bitmap.Palette,
                 pGreenBitmapInfo^, GreenBitmap^);
          GRIPForm.StatusBar1.Panels[1].Text :=
                   'Rotate Green loaded';
          Application.ProcessMessages;

          pBlueBitmapInfo := AllocMem(InfoSize);
          hBlueBitmap := GlobalAlloc(GMEM_MOVEABLE, ImageSize);
          if hBlueBitmap > 0 then MakeBitmapRotate := True else
          begin MakeBitmapRotate := False;
            DoMessages(39977);
            exit;
          end;
          BlueBitmap := GlobalLock(hBlueBitmap);
          GetDIB(GRIPForm.Image1.Picture.Bitmap.Handle,
                 GRIPForm.Image1.Picture.Bitmap.Palette,
                 pBlueBitmapInfo^,
                 BlueBitmap^);

          GRIPForm.StatusBar1.Panels[1].Text := 'Rotate RGB loaded';
          GRIPForm.Gauge1.Progress := 0;
          Application.ProcessMessages;

          if DO_RGBRotate then begin
            ILStart := (0);
            IWStart := (0);
            ILEnd := (ImageHeight);
            IWEnd := (ImageWidth);
            for IL := ILStart to ILEnd do begin
              for IW := IWStart to IWEnd do begin
         {TheColor:= GetPixel(hTRIPDC,IW,IL);
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);}
                WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
                lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
                lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
                BlueColor := lpPixelB^;
                GreenColor := lpPixelG^;
                RedColor := lpPixelR^;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(RedBitmap)^[WherePixel];
                lpPixelG := @PHugeByteArray(RedBitmap)^[WherePixel +1];
                lpPixelR := @PHugeByteArray(RedBitmap)^[WherePixel +2];
                lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ :=RedColor;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(GreenBitmap)^[WherePixel];
                lpPixelG := @PHugeByteArray(GreenBitmap)^[WherePixel+ 1];
                lpPixelR := @PHugeByteArray(GreenBitmap)^[WherePixel+ 2];
                lpPixelB^ := 0; lpPixelG^ := GreenColor; lpPixelR^ := 0;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(BlueBitmap)^[WherePixel];
                lpPixelG := @PHugeByteArray(BlueBitmap)^[WherePixel +1];
                lpPixelR := @PHugeByteArray(BlueBitmap)^[WherePixel +2];
                lpPixelB^ := BlueColor; lpPixelG^ := 0; lpPixelR^ :=0;
              end;
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done1(Per_Done);
            end;
          end; {of IF DO_RGBRotate}
          if DO_RGBNegRotate then begin
            ILStart := (0);
            IWStart := (0);
            ILEnd := (ImageHeight);
            IWEnd := (ImageWidth);
            for IL := ILStart to ILEnd do begin
              for IW := IWStart to IWEnd do begin
{         TheColor:= GetPixel(hTRIPDC,IW,IL);
         RedColor:= GetRValue(TheColor);
         BlueColor:= GetBValue(TheColor);
         GreenColor:= GetGValue(TheColor);}
                WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
                lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
                lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
                BlueColor := lpPixelB^;
                GreenColor := lpPixelG^;
                RedColor := lpPixelR^;
                RedColor := (255 - RedColor);
                BlueColor := (255 - BlueColor);
                GreenColor := (255 - GreenColor);
                if bCMYK then begin
                  if RedColor > GreenColor then CMY := RedColor else
                    CMY := GreenColor;
                  if BlueColor > CMY then CMY := BlueColor;
                  if CMY > 0 then begin
                    RedColor := (RedColor - CMY);
                    BlueColor := (BlueColor - CMY);
                    GreenColor := (GreenColor - CMY);
                  end;
                end;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(RedBitmap)^[WherePixel];
                lpPixelG := @PHugeByteArray(RedBitmap)^[WherePixel +1];
                lpPixelR := @PHugeByteArray(RedBitmap)^[WherePixel +2];
                lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ :=RedColor;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(GreenBitmap)^[WherePixel];
                lpPixelG := @PHugeByteArray(GreenBitmap)^[WherePixel+ 1];
                lpPixelR := @PHugeByteArray(GreenBitmap)^[WherePixel+ 2];
                lpPixelB^ := 0; lpPixelG^ := GreenColor; lpPixelR^ :=0;
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(BlueBitmap)^[WherePixel];
                lpPixelG := @PHugeByteArray(BlueBitmap)^[WherePixel +1];
                lpPixelR := @PHugeByteArray(BlueBitmap)^[WherePixel +2];
                lpPixelB^ := BlueColor; lpPixelG^ := 0; lpPixelR^ :=0;
              end;
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done1(Per_Done);
            end;
          end; {of IF DO_RGBNegRotate}


          dc := GetDc(0);
          hBmR := CreateDiBitmap(dc,
                                 pRedBitmapInfo^.bmiHeader,
                                 CBM_INIT,
                                 pChar(RedBitmap),
                                 pRedBitmapInfo^,
                                 DIB_RGB_COLORS);
          hBmG := CreateDiBitmap(dc,
                                 pGreenBitmapInfo^.bmiHeader,
                                 CBM_INIT,
                                 pChar(GreenBitmap),
                                 pGreenBitmapInfo^,
                                 DIB_RGB_COLORS);
          hBmB := CreateDiBitmap(dc,
                                 pBlueBitmapInfo^.bmiHeader,
                                 CBM_INIT,
                                 pChar(BlueBitmap),
                                 pBlueBitmapInfo^,
                                 DIB_RGB_COLORS);
{  dc :=} ReleaseDc(0, dc); {Give back the screen dc}
  {Give back the screen dc ... compiler complains}
          bmR := TBitmap.Create; {Create a temporory TBitmap}
            {  FreeImage;}
          bmG := TBitmap.Create;
          bmB := TBitmap.Create;
{24 bit em}
          GlobalUnlock(hRedBitmap);
          GlobalUnlock(hGreenBitmap);
          GlobalUnlock(hBlueBitmap);
          bmR.Handle := hBmR; {Assign the handle}
          bmG.Handle := hBmG; {Assign the handle}
          bmB.Handle := hBmB; {Assign the handle}
        finally {Free up the memory we used}
          if (not MakeBitmapRotate) then Do_DeleteBitmapRotate;
        end;
      end else DoMessages(12);
    end else
    begin
      DoMessages(11);
{    dc := } ReleaseDc(0, dc);
  {Give back the screen dc ... compiler complains}
    end; {of if 24 bit}
  end {of if a picture}
  else DoMessages(10);
  Screen.Cursor := CRDEFAULT;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
end;
{---------------------------------------------------------------------}

procedure Do_DeleteBitmapRotate;
begin
  GlobalFree(hRedBitmap);
  FreeMem(pRedBitmapInfo, InfoSize);
  GlobalFree(hGreenBitmap);
  FreeMem(pGreenBitmapInfo, InfoSize);
  GlobalFree(hBlueBitmap);
  FreeMem(pBlueBitmapInfo, InfoSize);
  UndoImage;
  DeleteBitmapRotate := True;
{hRedBitmap, hGreenBitmap, hBlueBitmap,Undoh,Workh,Imageh: DWord;
pRedBitmapInfo, pGreenBitmapInfo, pBlueBitmapInfo,
pUndoInfo,pWorkInfo,pImageInfo : PBitmapInfo;
RedBitmap, GreenBitmap, BlueBitmap,Undo,Work,Image :Pointer;
}
end;
{---------------------------------------------------------------------}

procedure Do_TheRotate;
begin {}
  Inc(Counter);
  if Counter > 3 then Counter := 1;
  case Counter of
    1: begin
        GRIPForm.Image1.Picture.Bitmap := bmR; {Assign the bitmap}
        SelectPalette(GRIPForm.Image1.Picture.Bitmap.Canvas.Handle,
          GRIPForm.Image1.Picture.Bitmap.Palette, false);
      end;
    2: begin
        GRIPForm.Image1.Picture.Bitmap := bmG; {Assign the bitmap}
        SelectPalette(GRIPForm.Image1.Picture.Bitmap.Canvas.Handle,
          GRIPForm.Image1.Picture.Bitmap.Palette, false);
      end;
    3: begin
        GRIPForm.Image1.Picture.Bitmap := bmB; {Assign the bitmap}
        SelectPalette(GRIPForm.Image1.Picture.Bitmap.Canvas.Handle,
          GRIPForm.Image1.Picture.Bitmap.Palette, false);
      end;

  end; {of case}
end;
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}

procedure Do_Change(WhatColor: Integer);
var IL, IW: DWord;
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
begin {Get current Window DC}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;
        if WhatColor = 1 then
        begin
          GreenColor := 0 {GreenColor};
          BlueColor := 0 {BlueColor};
        end else
          if WhatColor = 2 then
          begin
            RedColor := 0 {RedColor};
            BlueColor := 0 {BlueColor};
          end else
            if WhatColor = 3 then
            begin
              RedColor := 0 {RedColor};
              GreenColor := 0 {GreenColor};
            end;
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := GreenColor; lpPixelR^ :=
        RedColor;
      end; {of  Image Width}
      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    SetImage;
  end; {OF MAKE BITMAP}
end; {of Change colors}
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}

function WhatsMySize(FFileName: string): Integer;
var
  I, FilterSize, Code: Integer;
  FileLen: Word;
begin
  WhatsMySize := 3;
  FileLen := Length(FFileName);
  I := FileLen - 1;
  while (I <> 0) and ((FFileName[I] <> '.')) do
    Dec(I); {Dec's while looking, then Inc's once to total a count}
  Inc(I, 2);
  if ((FFileName[I] = 'L') or (FFileName[I] = 'l') or
    (FFileName[I] = 'r') or (FFileName[I] = 'R')) then
  begin
    Inc(I);
    Val(FFileName[I], FilterSize, Code);
    if Code <> 0 then Codefx(FFileName, Code)
    else WhatsMySize := FilterSize;
  end else
    if ((FFileName[I] = '2') or (FFileName[I] = '8')) then
    begin
      Inc(I);
      Val(FFileName[I], FilterSize, Code);
      if Code <> 0 then Codefx(FFileName, Code)
      else WhatsMySize := FilterSize;
    end else DoMessages(39982);
end;

{---------------------------------------------------------------------}

procedure DoLoader;
var P_File: PrefFile;
var PathS: string;
begin
  PathS := ExtractFilePath(ParamStr(0)) + 'Grip.pof';
  if FileExists(PathS) then
  begin
    AssignFile(P_File, PathS);
    Reset(P_File);
    if IoResult <> 0 then DoMessages(39984);
    Read(P_File, PreRcd);
    CloseFile(P_File);
    SetPreferences;
  end else DoMessages(39985);
end;

procedure SetPreferences;
begin {after loading}
  with PreRcd do begin
    Started := PStarted;
    StartedNameNumber := PStartedNameNumber;
    HiddenString:=PHiddenString;
    MapBaseColor := PMapBaseColor;
    RPM_Program := PRPM_Program;
    ImagePath := PFilePath;
    FilterPath := PFilterPath;
    RPM_DEM := PRPM_DEM;
    RPM_Vectors := PRPM_Vectors;
    RPM_VDatabase := PRPM_VDatabase;
    RPM_Storage := PRPM_Storage;
{Menu}
    OpenWithPreview := POpenWithPreview;
    SaveWithPreview := PSaveWithPreview;
    DisplayConvert32 := PDisplayConvert32;
    ToggleOn := PToggleOn;
    DoneBeepOn := PDoneBeepOn;
    ErrorBeepOn := PErrorBeepOn;
    ErrorVoiceOn := PErrorVoiceOn;
    VoicesOn := PVoicesOn;
    BellsOn := PBellsOn;
    WhistlesOn := PWhistlesOn;
    AutoRange := PAutoRange;
    BelowZero := PBelowZero;
    ClipR := PClipR;
    Do_Ex_com := PDo_Ex_com;
    V_Absolute := PV_Absolute;
    R_AutoTT := PR_AutoTT;
    S_Threshold := PS_Threshold;
    Toggle_D_RGB := PToggle_D_RGB;
    Toggle_D_R := PToggle_D_R;
    Toggle_D_G := PToggle_D_G;
    Toggle_D_B := PToggle_D_B;
    bST_Min := PbST_Min;
    bST_Max := PbST_Max; {0,255}
    iAT_Min := PiAT_Min;
    iAT_Max := PiAT_Max;
    All_Max := PAll_Max;
    All_Min := PAll_Min;
    dAT_Max := PdAT_Max;
    dAT_Min := PdAT_Min;
    RasterFormX := PRasterFormX;
    RasterFormY := PRasterFormY;
    REIVX := PREIVX;
    REIVY := PREIVY;
    ColorFormX := PColorFormX;
    ColorFormY := PColorFormY;
    OptionsFormX := POptionsFormX;
    OptionsFormY := POptionsFormY;
    PrintersizeFormX := PPrintersizeFormX;
    PrintersizeFormY := PPrintersizeFormY;
    ResizeFormX := PResizeFormX;
    ResizeFormY := PResizeFormY;
    SystemInfoFormX := PSystemInfoFormX;
    SystemInfoFormY := PSystemInfoFormY;
    ImageInfoFormX := PImageInfoFormX;
    ImageInfoFormY := PImageInfoFormY;
    ViewCursorScreenX := PViewCursorScreenX;
    ViewCursorScreenY := PViewCursorScreenY;
    LabelObjectsFormX := PLabelObjectsFormX;
    LabelObjectsFormY := PLabelObjectsFormY;
    ObjectMarkFormX := PObjectMarkFormX;
    ObjectMarkFormY := PObjectMarkFormY;
    RotateFormX := PRotateFormX;
    RotateFormY := PRotateFormY;
    MagniFormX := PMagniFormX;
    MagniFormY := PMagniFormY;
    PBandHdrFormX := PPBandHdrFormX;
    PBandHdrFormY := PPBandHdrFormY;
    PBandsX := PPBandsX;
    PBandsY := PPBandsY;
    PBHisX := PPBHisX;
    PBHisY := PPBHisY;
    HistogramFormX := PHistogramFormX;
    HistogramFormY := PHistogramFormY;
    FormPrintX := PFormPrintX;
    FormPrintY := PFormPrintY;
    FEditFormX := PFEditFormX;
    FEditFormY := PFEditFormY;
    FFTFormX := PFFTFormX;
    FFTFormY := PFFTFormY;
    ClassificationFormX := PClassificationFormX;
    ClassificationFormY := PClassificationFormY;
    LinearFormX := PLinearFormX;
    LinearFormY := PLinearFormY;
    LineProfileFormX := PLineProfileFormX;
    LineProfileFormY := PLineProfileFormY;
    DistanceFormX := PDistanceFormX;
    DistanceFormY := PDistanceFormY;
    PixelAlgebraFormX := PPixelAlgebraFormX;
    PixelAlgebraFormY := PPixelAlgebraFormY;
    MacroFormX := PMacroFormX;
    MacroFormY := PMacroFormY;
    VRLabFormX := PVRLabFormX;
    VRLabFormY := PVRLabFormY;
    MoxelFormX := PMoxelFormX;
    MoxelFormY := PMoxelFormY;
    VoxelFormX := PVoxelFormX;
    VoxelFormY := PVoxelFormY;
    PixelFormX := PPixelFormX;
    PixelFormY := PPixelFormY;
    AboutBoxX := PAboutBoxX;
    AboutBoxY := PAboutBoxY;
    MessageX := PMessageX;
    MessageY := PMessageY;
    ColorRef := PColorRef; ColorWhite := PColorWhite;
    ColorBlack := PColorBlack; CurrentColor := PCurrentColor;
    ColorPURPLE := PColorPURPLE; ColorDPURPLE := PColorDPURPLE;
    ColorYELLOW := PColorYELLOW; ColorLYELLOW := PColorLYELLOW;
    Color9 := PColor9;
    Color1 := PColor1; Color2 := PColor2;
    Color3 := PColor3; Color4 := PColor4;
    Color5 := PColor5; Color6 := PColor6;
    Color7 := PColor7; Color8 := PColor8;
    UVW := PUVW; VDW := PVDW; VMW := PVMW; VLW := PVLW; UDW := PUDW;
    UMW := PUMW; ULW := PULW; DDW := PDDW;
    DMW := PDMW; DLW := PDLW; MDW := PMDW; MMW := PMMW; MLW := PMLW;
    LDW := PLDW; LMW := PLMW; LLW := PLLW;
    UVC := PUVC; VDC := PVDC; VMC := PVMC; VLC := PVLC; UDC := PUDC;
    UMC := PUMC; ULC := PULC; DDC := PDDC;
    DMC := PDMC; DLC := PDLC; MDC := PMDC; MMC := PMMC; MLC := PMLC;
    LDC := PLDC; LMC := PLMC; LLC := PLLC;
    UVF := PUVF; VDF := PVDF; VMF := PVMF; VLF := PVLF; UDF := PUDF;
    UMF := PUMF; ULF := PULF; DDF := PDDF;
    DMF := PDMF; DLF := PDLF; MDF := PMDF; MMF := PMMF; MLF := PMLF;
    LDF := PLDF; LMF := PLMF; LLF := PLLF;
    UVA := PUVA; VDA := PVDA; VMA := PVMA; VLA := PVLA; UDA := PUDA;
    UMA := PUMA; ULA := PULA; DDA := PDDA;
    DMA := PDMA; DLA := PDLA; MDA := PMDA; MMA := PMMA; MLA := PMLA;
    LDA := PLDA; LMA := PLMA; LLA := PLLA;
    UVR := PUVR; VDR := PVDR; VMR := PVMR; VLR := PVLR; UDR := PUDR;
    UMR := PUMR; ULR := PULR; DDR := PDDR;
    DMR := PDMR; DLR := PDLR; MDR := PMDR; MMR := PMMR; MLR := PMLR;
    LDR := PLDR; LMR := PLMR; LLR := PLLR;
    UVT := PUVT; VDT := PVDT; VMT := PVMT; VLT := PVLT; UDT := PUDT;
    UMT := PUMT; ULT := PULT; DDT := PDDT;
    DMT := PDMT; DLT := PDLT; MDT := PMDT; MMT := PMMT; MLT := PMLT;
    LDT := PLDT; LMT := PLMT; LLT := PLLT;
    UVB := PUVB; VDB := PVDB; VMB := PVMB; VLB := PVLB; UDB := PUDB;
    UMB := PUMB; ULB := PULB; DDB := PDDB;
    DMB := PDMB; DLB := PDLB; MDB := PMDB; MMB := PMMB; MLB := PMLB;
    LDB := PLDB; LMB := PLMB; LLB := PLLB;
    UVU := PUVU; VDU := PVDU; VMU := PVMU; VLU := PVLU; UDU := PUDU;
    UMU := PUMU; ULU := PULU; DDU := PDDU;
    DMU := PDMU; DLU := PDLU; MDU := PMDU; MMU := PMMU; MLU := PMLU;
    LDU := PLDU; LMU := PLMU; LLU := PLLU;
    UVS := PUVS; VDS := PVDS; VMS := PVMS; VLS := PVLS; UDS := PUDS;
    UMS := PUMS; ULS := PULS; DDS := PDDS;
    DMS := PDMS; DLS := PDLS; MDS := PMDS; MMS := PMMS; MLS := PMLS;
    LDS := PLDS; LMS := PLMS; LLS := PLLS;
  end;
end;
{---------------------------------------------------------------------}

procedure DoSaver;
var P_File: PrefFile;
var PathS: string;
begin
  PathS := ExtractFilePath(ParamStr(0)) + 'Grip.pof';
  if (not FileExists(PathS)) then
      DoMessages(2);{    AboutGrip.Show;}
  GetPreferences;
{showmessage(inttostr(Colorreg));}
  AssignFile(P_File, PathS);
  Rewrite(P_File);
  if IoResult <> 0 then
  begin
    DoMessages(39986);
  end;
  write(P_File, PreRcd);
  CloseFile(P_File);
end;
{---------------------------------------------------------------------}

procedure GetPreferences;
begin {before saving}
  with PreRcd do begin
{This is my secret string ? as text?}
    PHiddenString:=HiddenString;
    PRPM_Program := RPM_Program;
    PFilePath := ImagePath;
    PFilterPath := FilterPath;
    PRPM_DEM := RPM_DEM;
    PRPM_Vectors := RPM_Vectors;
    PRPM_VDatabase := RPM_VDatabase;
    PRPM_Storage := RPM_Storage;
{Menu}
    POpenWithPreview := OpenWithPreview;
    PSaveWithPreview := SaveWithPreview;
    PDisplayConvert32 := DisplayConvert32;
    PToggleOn := ToggleOn;
    PDoneBeepOn := DoneBeepOn;
    PErrorBeepOn := ErrorBeepOn;
    PErrorVoiceOn := ErrorVoiceOn;
    PVoicesOn := VoicesOn;
    PBellsOn := BellsOn;
    PWhistlesOn := WhistlesOn;
    PAutoRange := AutoRange;
    PBelowZero := BelowZero;
    PClipR := ClipR;
    PDo_Ex_com := Do_Ex_com;
    PV_Absolute := V_Absolute;
    PR_AutoTT := R_AutoTT;
    PS_Threshold := S_Threshold;
    PToggle_D_RGB := Toggle_D_RGB;
    PToggle_D_R := Toggle_D_R;
    PToggle_D_G := Toggle_D_G;
    PToggle_D_B := Toggle_D_B;
    PbST_Min := bST_Min;
    PbST_Max := bST_Max;
    PdAT_Max := dAT_Max;
    PdAT_Min := dAT_Min;
    PiAT_Min := iAT_Min;
    PiAT_Max := iAT_Max;
    PAll_Max := All_Max;
    PAll_Min := All_Min;

    PMapBaseColor := MapBaseColor;
    PStarted := Started;
    PStartedNameNumber := StartedNameNumber;
    PRasterFormX := RasterFormX;
    PRasterFormY := RasterFormY;
    PREIVX := REIVX;
    PREIVY := REIVY;
    PColorFormX := ColorFormX;
    PColorFormY := ColorFormY;
    POptionsFormX := OptionsFormX;
    POptionsFormY := OptionsFormY;
    PPrintersizeFormX := PrintersizeFormX;
    PPrintersizeFormY := PrintersizeFormY;
    PResizeFormX := ResizeFormX;
    PResizeFormY := ResizeFormY;
    PSystemInfoFormX := SystemInfoFormX;
    PSystemInfoFormY := SystemInfoFormY;
    PImageInfoFormX := ImageInfoFormX;
    PImageInfoFormY := ImageInfoFormY;
    PViewCursorScreenX := ViewCursorScreenX;
    PViewCursorScreenY := ViewCursorScreenY;
    PLabelObjectsFormX := LabelObjectsFormX;
    PLabelObjectsFormY := LabelObjectsFormY;
    PObjectMarkFormX := ObjectMarkFormX;
    PObjectMarkFormY := ObjectMarkFormY;
    PRotateFormX := RotateFormX;
    PRotateFormY := RotateFormY;
    PMagniFormX := MagniFormX;
    PMagniFormY := MagniFormY;
    PPBandHdrFormX := PBandHdrFormX;
    PPBandHdrFormY := PBandHdrFormY;
    PPBandsX := PBandsX;
    PPBandsY := PBandsY;
    PPBHisX := PBHisX;
    PPBHisY := PBHisY;
    PHistogramFormX := HistogramFormX;
    PHistogramFormY := HistogramFormY;
    PFormPrintX := FormPrintX;
    PFormPrintY := FormPrintY;
    PFEditFormX := FEditFormX;
    PFEditFormY := FEditFormY;
    PFFTFormX := FFTFormX;
    PFFTFormY := FFTFormY;
    PClassificationFormX := ClassificationFormX;
    PClassificationFormY := ClassificationFormY;
    PLinearFormX := LinearFormX;
    PLinearFormY := LinearFormY;
    PLineProfileFormX := LineProfileFormX;
    PLineProfileFormY := LineProfileFormY;
    PDistanceFormX := DistanceFormX;
    PDistanceFormY := DistanceFormY;
    PPixelAlgebraFormX := PixelAlgebraFormX;
    PPixelAlgebraFormY := PixelAlgebraFormY;
    PMacroFormX := MacroFormX;
    PMacroFormY := MacroFormY;
    PVRLabFormX := VRLabFormX;
    PVRLabFormY := VRLabFormY;
    PMoxelFormX := MoxelFormX;
    PMoxelFormY := MoxelFormY;
    PVoxelFormX := VoxelFormX;
    PVoxelFormY := VoxelFormY;
    PPixelFormX := PixelFormX;
    PPixelFormY := PixelFormY;
    PAboutBoxX := AboutBoxX;
    PAboutBoxY := AboutBoxY;
    PMessageX := MessageX;
    PMessageY := MessageY;
    PColorRef := ColorRef; PColorWhite := ColorWhite;
    PColorBlack := ColorBlack; PCurrentColor := CurrentColor;
    PColorPURPLE := ColorPURPLE; PColorDPURPLE := ColorDPURPLE;
    PColorYELLOW := ColorYELLOW; PColorLYELLOW := ColorLYELLOW;
    PColor9 := Color9;
    PColor1 := Color1; PColor2 := Color2; PColor3 := Color3; PColor4
    := Color4;
    PColor5 := Color5; PColor6 := Color6; PColor7 := Color7; PColor8
    := Color8;
    PUVW := UVW; PVDW := VDW; PVMW := VMW; PVLW := VLW; PUDW := UDW;
    PUMW := UMW; PULW := ULW; PDDW := DDW;
    PDMW := DMW; PDLW := DLW; PMDW := MDW; PMMW := MMW; PMLW := MLW;
    PLDW := LDW; PLMW := LMW; PLLW := LLW;
    PUVC := UVC; PVDC := VDC; PVMC := VMC; PVLC := VLC; PUDC := UDC;
    PUMC := UMC; PULC := ULC; PDDC := DDC;
    PDMC := DMC; PDLC := DLC; PMDC := MDC; PMMC := MMC; PMLC := MLC;
    PLDC := LDC; PLMC := LMC; PLLC := LLC;
    PUVF := UVF; PVDF := VDF; PVMF := VMF; PVLF := VLF; PUDF := UDF;
    PUMF := UMF; PULF := ULF; PDDF := DDF;
    PDMF := DMF; PDLF := DLF; PMDF := MDF; PMMF := MMF; PMLF := MLF;
    PLDF := LDF; PLMF := LMF; PLLF := LLF;
    PUVA := UVA; PVDA := VDA; PVMA := VMA; PVLA := VLA; PUDA := UDA;
    PUMA := UMA; PULA := ULA; PDDA := DDA;
    PDMA := DMA; PDLA := DLA; PMDA := MDA; PMMA := MMA; PMLA := MLA;
    PLDA := LDA; PLMA := LMA; PLLA := LLA;
    PUVR := UVR; PVDR := VDR; PVMR := VMR; PVLR := VLR; PUDR := UDR;
    PUMR := UMR; PULR := ULR; PDDR := DDR;
    PDMR := DMR; PDLR := DLR; PMDR := MDR; PMMR := MMR; PMLR := MLR;
    PLDR := LDR; PLMR := LMR; PLLR := LLR;
    PUVT := UVT; PVDT := VDT; PVMT := VMT; PVLT := VLT; PUDT := UDT;
    PUMT := UMT; PULT := ULT; PDDT := DDT;
    PDMT := DMT; PDLT := DLT; PMDT := MDT; PMMT := MMT; PMLT := MLT;
    PLDT := LDT; PLMT := LMT; PLLT := LLT;
    PUVB := UVB; PVDB := VDB; PVMB := VMB; PVLB := VLB; PUDB := UDB;
    PUMB := UMB; PULB := ULB; PDDB := DDB;
    PDMB := DMB; PDLB := DLB; PMDB := MDB; PMMB := MMB; PMLB := MLB;
    PLDB := LDB; PLMB := LMB; PLLB := LLB;
    PUVU := UVU; PVDU := VDU; PVMU := VMU; PVLU := VLU; PUDU := UDU;
    PUMU := UMU; PULU := ULU; PDDU := DDU;
    PDMU := DMU; PDLU := DLU; PMDU := MDU; PMMU := MMU; PMLU := MLU;
    PLDU := LDU; PLMU := LMU; PLLU := LLU;
    PUVS := UVS; PVDS := VDS; PVMS := VMS; PVLS := VLS; PUDS := UDS;
    PUMS := UMS; PULS := ULS; PDDS := DDS;
    PDMS := DMS; PDLS := DLS; PMDS := MDS; PMMS := MMS; PMLS := MLS;
    PLDS := LDS; PLMS := LMS; PLLS := LLS;
  end;
end;
{---------------------------------------------------------------------}
(*
Do_Messages(
{1..9999 mtInformation	A message box containing a blue "i".}
{10000..19999 mtConfirmation	A message box containing a green question mark.}
{20000..29999 mtWarning   A message box containing a yellow exclamation point symbol.}
{30000..40000 mtError  A message box containing a red stop sign.}

Codefx(WhatString:String;Codein:Integer);
Do_Messages(39979);
{12..9998 mtInformation	A message box containing a blue "i".}
12:Messagestr:= 'Image not loaded';
{10001..19999 mtConfirmation	A message box containing a green question mark.}
{20001..29999 mtWarning   A message box containing a yellow exclamation point symbol.}
{30001..39989 mtError  A message box containing a red stop sign.}
39989:Messagestr:='Image less than 1024x1024';
*)

procedure DoMessages(i: Integer);
var
  Messagestr: string;
  HelpContextl: Longint;
  s: array[0..250] of char;
begin
  HelpContextl := 0;
  case i of {Do_Messages(11}
{1..9999 mtInformation	A message box containing a blue "i".}
    1: Messagestr := 'Resistance is futile';
    2: Messagestr := 'the GRIP program options file' + #13#10 +
      ExtractFilePath(ParamStr(0)) + 'GRIP.pof' + #13#10 +
        'Does NOT Exist:... Will Make it' + #13#10 +
        'Please set Options and Directories in' + #13#10 +
        'Investigate Menu: Options... ';
    9: Messagestr := 'Under Construction: nothing happened';
    10: Messagestr := 'Image not loaded';
    11: Messagestr := 'Requires True Color (24 bit) Colors Setting';
    12: Messagestr := 'Requires TRUE COLOR (24 bit) Image';
    13: Messagestr := 'Improper Choices: nothing happened';
    14: Messagestr := 'I found one';
    15: Messagestr := 'Number input wrong,' + #13 + #10 +
      'Please try again';
    16: Messagestr := 'Registration Number invalid';
    17: Messagestr := 'Not Registered!' + #13 + #10 +
      'Please register Raster';
    18: Messagestr := 'Gotta have a Distance Value';
    19: Messagestr := 'Invalid Distance Values';
    20: Messagestr := 'Cannot Change unless Loaded';
    21: Messagestr := 'Only Rotate has more than 2 Stages';
    22: Messagestr := 'Only Sobel and Rotate have more than 1 Stage';
    23: Messagestr := 'Cannot Change unless Clear';
    24: Messagestr := 'Top Center Square value wrong';
    25: Messagestr := 'First Load an image to display';
    26: Messagestr := 'no font';
    27: Messagestr := 'The DIS name MUST be Different from DIH' +
      #13#10 +
        'else many .B?? will have the same name';
    28: Messagestr := '3. Gotta have a PNG File name';
    29: Messagestr := 'Band 1 File does not Exist!';
    30: Messagestr := '1. Header record needed';
    31: Messagestr := '2. Gotta have a Band 1 File name';
    32: Messagestr := '2. Gotta have a Band 2 File name';
    33: Messagestr := '2. Gotta have a Band 3 File name';
    34: Messagestr := 'Band 2 File does not Exist!';
    35: Messagestr := 'Band 3 File does not Exist!';
    36: Messagestr := 'Some size is wrong';
    37: Messagestr := 'Already Printing';
    38: Messagestr := 'Printing aborted';
    39: Messagestr := 'RGB Boolean set to Somethingthing!';
    40: Messagestr := 'Converts 32 to 24 bit Color images';
    41: Messagestr := '4bit to 24 bit bitmapped';
    42: Messagestr := '8bit to 24 bit bitmapped';
    43: Messagestr := '15bit to 24 bit bitmapped';
    44: Messagestr := '16bit to 24 bit bitmapped';
    45: Messagestr := '32bit to 24 bit bitmapped';
    46: Messagestr := 'There is no image currently loaded to save.';
{  Do_Messages(40 }

    9999: Messagestr := 'Resistance is futile'
      + #13#10 + 'All Messages end here';
{10000..19999 mtConfirmation	A message box containing a green question mark.}
    10000: Messagestr := 'Do you wanna dance?';
    10001: Messagestr :=
      'a DIH Header exists, use+append+overwrite instead?';
{20000..29999 mtWarning   A message box containing a yellow exclamation point symbol.}
    20000: Messagestr := 'Danger Danger';
    20001: Messagestr := 'order.txt Files not found';
    20002: Messagestr := 'license.doc Files not found';
    20003: Messagestr := 'grip.html Files not found';
    20004: Messagestr := 'Grip will fail without Registration' +#13#10+
                         'Registration Warning' + #13#10 +
                         'See Grip About';
{Do_Messages( 20004}
{30000..40000 mtError  A message box containing a red stop sign.}
    30000: Messagestr := 'There is an Error in the system';
    30001: Messagestr := 'Grip failed without Registration' +#13#10+
                         'Registration Error' + #13#10 +
                         'See Grip Register';

{DoMessages( 39960); }
    39959: Messagestr := 'Not square';
    39960: Messagestr := 'Not a power of 2';
    39961: Messagestr := 'too big 2048x2048 Maximum';
    39962: Messagestr := 'did not converge';
    39963: Messagestr := 'too many numbers';
    39964: Messagestr := 'DIH Projection is NOT Valid';
    39965: Messagestr := 'DIH->DIS LL Projection Error';
    39966: Messagestr := 'DIH / Extent / Coordinates Valid not Checked.. Invalid?';
    39967: Messagestr :=
      'Header Crashed: Cancel or fix DIS Subset Width';
    39968: Messagestr := 'File unknown';
    39969: Messagestr := 'Not a Radar DAT file';
    39970: Messagestr :=
      'Header Crashed: Cancel or fix Number of Bands';
    39971: Messagestr := 'Header Crashed: Cancel or fix Coordinates';
    39972: Messagestr := 'NO HDR FILE NAME!?! ... Bad File Error';
    39973: Messagestr := 'Error - no files in the Zip file';
    39974: Messagestr := 'Disk full!?! ... Bad File Error';
    39975: Messagestr := 'Image Undone or crashed' +#13#10+
                         'Restart Line Profile or exit';
    39976: Messagestr := ' An error was detected when'+#13#10+
                         'trying to fetch registration info.';
    39977: Messagestr := 'You Crashed ! OUT of Resources!';
    39978: Messagestr := 'Image less than 1024x1024';
    39979: Messagestr := 'Image less than 512x512';
    39980: Messagestr := 'Image less than 256x256';
    39981: Messagestr := 'Stats Error.. Image buggered';
    39982: Messagestr := 'Filter File unknown';
    39983: Messagestr := 'Filename has reached 999';
    39984: Messagestr := 'Failed reading GRIP.pof File';
    39985: Messagestr := 'GRIP.pof Does NOT Exist';
    39986: Messagestr := 'Failed writing GRIP.pof File';
    39987: Messagestr := 'Stat error';
    39988: Messagestr := 'Height not equal to BR';
    39989: Messagestr := 'Width not equal to RC';
    39990: Messagestr :=
              'Horizontal height: 1and2, 3and4 must be same height'
     +#13#10+ 'Vertical width: 1and3, 2and4 must be same width';
    39991: Messagestr := 'Horizontal height not same = equal';
    39992: Messagestr := 'Vertical Width not same = equal';
    39993: Messagestr :=
      'Variables blank, files invalid, or page turned';
    39994: Messagestr := 'Not a DIH file Version: ' +DIHVersion;
    39995: Messagestr := 'Not a DIS file Version: ' +DISVersion;
    39996: Messagestr := 'Not a DIP file Version: ' +DIPVersion;
    39997: Messagestr := 'NO HDR FILE NAME!?!';
    39998: Messagestr := 'Error opening file';
    39999: Messagestr := 'There is an Error in the system';
    40000: Messagestr := 'FATAL Error creating bitmap... byebye';
  end;

  case i of {2,147,483,648..2,147,483,647}
{mtInformation	A message box containing a blue "i".}
    1..9999: MessageDlgPos(Messagestr,
        mtInformation,
        [mbOK], {mbYesNoCancel,}
        HelpContextl,
        MessageX,
        MessageY);
{mtConfirmation	A message box containing a green question mark.}
    10000..19999: MessageDlgPos(Messagestr,
        mtConfirmation,
                {[mbOK],} mbYesNoCancel,
        HelpContextl,
        MessageX,
        MessageY);
{mtWarning   A message box containing a yellow exclamation point symbol.}
    20000..29999: MessageDlgPos(Messagestr,
        mtWarning,
        [mbOK], {mbYesNoCancel,}
        HelpContextl,
        MessageX,
        MessageY);
{mtError  A message box containing a red stop sign.}
    30000..40000: begin
        if ErrorBeepOn then Beep(10000, 1000); {Beep;}
        if (ErrorVoiceOn) then
        begin
          StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'ERRORV.WAV');
                       {sndPlaySoundA(s, 0);}
          if (MMSysHandle <> 0) then PlaySound(s, {SND_ASYNC} 0);
        end;
        MessageDlgPos(Messagestr,
          mtError,
          [mbOK], {mbYesNoCancel,}
          HelpContextl,
          MessageX,
          MessageY);
      end;
  end;
end;
(*TMsgDlgBtn = (mbYes, mbNo, mbOK, mbCancel,
             mbAbort, mbRetry, mbIgnore,
             mbAll, mnNoToAll, mbYesToAll, mbHelp);
const
  mbYesNoCancel = [mbYes, mbNo, mbCancel];
  mbOKCancel = [mbOK, mbCancel];
  mbAbortRetryIgnore = [mbAbort, mbRetry, mbIgnore];

mbYes	A button with 'Yes' on its face.
mbNo	A button the text 'No' on its face.
mbOK	A button the text 'OK' on its face.
mbCancel	A button with the text 'Cancel' on its face.
mbAbort	A button with the text 'Abort' on its face
mbRetry	A button with the text 'Retry' on its face
mbIgnore	A button the text 'Ignore' on its face
mbAll	A button with the text 'All' on its face
mbNoToAll	A button with the text 'No to All' on its face
mbYesToAll	A button with the text 'Yes to All' on its face
mbHelp	A button with the text 'Help' on its face

RETURN VALUES
mrNone	 mrAbort	mrYes
mrOk	 mrRetry	mrNo
mrCancel mrIgnore	mrAll
*)
{---------------------------------------------------------------------}
(*      Begin
StrPCopy(s, 'DONE.WAV');
{Play the sound asynchronously}
sndPlaySound(s, 0); {see mmsystem.hlp for other values}
{
If you specify the SND_MEMORY flag, lpszSoundName must point to an
in-memory image of a waveform sound.
If the sound is stored as a resource, use
LoadResource and LockResource to load and lock the resource and get a
pointer to it.
}
       {setimage calls the ImageDone}
       {Whistle is a for i:= 100 do
       go up then down then around }
               { Beep( Pitch, Duration );}
{      Beep(1000,100);}{Order of units must make difference?}
      end;*)

{---------------------------------------------------------------------}

end.
