{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gPBHdr;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls;

type
  TPBandHdrForm = class(TForm)
    DDRIDXMemo: TRichEdit;
    DDRHdrEdit: TEdit;
    DDRPrintBtn: TSpeedButton;
    DDRCopyBtn: TBitBtn;
    DDRIDXHelpBtn: TBitBtn;
    ExitButton: TSpeedButton;
    procedure DDRCopyBtnClick(Sender: TObject);
    procedure DDRPrintBtnClick(Sender: TObject);
    procedure DDRIDXHelpBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure Load(InFileName: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PBandHdrForm: TPBandHdrForm;

implementation

{$R *.DFM}
uses gGlobal, gGrip;

procedure TPBandHdrForm.FormCreate(Sender: TObject);
begin
  left := PBandHdrFormX;
  top := PBandHdrFormY;
end;

procedure TPBandHdrForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  PBandHdrFormX := PBandHdrForm.left;
  PBandHdrFormY := PBandHdrForm.top;
  DoSaver;
  {FormControl:=15;
  GRIPForm.FreeForm;}
end;

procedure TPBandHdrForm.ExitButtonClick(Sender: TObject);
begin
  Close;
end;


procedure TPBandHdrForm.DDRCopyBtnClick(Sender: TObject);
begin
  DDRIDXMemo.CopytoClipboard;
end;

procedure TPBandHdrForm.DDRPrintBtnClick(Sender: TObject);
begin
  DDRIDXMemo.Print(DDRHdrEdit.Text);
end;

procedure TPBandHdrForm.DDRIDXHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(2003);
end;

procedure TPBandHdrForm.Load(InFileName: string);
begin
  DDRIDXMemo.Clear;
  DDRIDXMemo.Lines.LoadfromFile(InFileName);
end;
end.
