{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gUILinear;
interface

{ Place a USES declaration here }
uses
  Windows, Messages, SysUtils, Classes, Graphics,
  gGlobal, Controls, Forms, Dialogs,
  StdCtrls, { WinTypes, } Buttons;

{ Place CONST, TYPE, and VAR declarations here }

{ Place PROCEDURE and FUNCTION declarations here }
{Do_RGBContour;}
procedure AContour(CIntervalRed, CIntervalGreen, CIntervalBlue:
  Integer);
{Do_ WIDE RGBContour;}
procedure Do_Contour(CIntervalRed, CIntervalGreen, CIntervalBlue:
  Integer);

procedure Do_Measured;
procedure Do_Measured_Do(InDistance, PixelLine, MeanderDistance:
  Integer);             

{Line Profile calls its own form}
procedure DoSnake(InX, InY: Integer; Colors: TColor);


procedure Do_EdgeFollow(CIntervalRed: integer); {Calls Nibbler}
procedure Do_EdgeFlow(CIntervalRed: integer);
procedure ContourInterval(CIntervalRed: integer);
procedure DoWireframe(CIntervalRed: integer);

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

implementation

{ Place a second USES declaration here }
uses gDistance, gPBands, gUHistoCC, gLinear, gMacro;
{ Place private LABEL, CONST, TYPE, and VAR declarations here }

{StartDrawing:Boolean}{Linear Mouser flag}
{ Place PROCEDURE and FUNCTION bodies here }
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure AContour(CIntervalRed, CIntervalGreen, CIntervalBlue:
  Integer);
var
  CenterPixel, TheColor: Longint;
  RCenter, GCenter, BCenter,
    RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd,
    Size: Integer;
  Center, Where, sX, sY, IL, IW: Dword;
begin {Get current Window DC}
  HowMany := 3; {WhatsMySize(InFilterName);}
  Where := (-Trunc(HowMany / 2)); {-1;}
  Center := (Trunc(HowMany / 2) {+1}); {2;}
     {Begin of Whole Autorange = True... Do Twice}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        {Get the Center Pixel}
{        CenterPixel := GetPixel(hUnDoDC, IW,IL);
        RCenter:= GetRValue(CenterPixel);
        GCenter:= GetGValue(CenterPixel);
        BCenter:= GetBValue(CenterPixel);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BCenter := lpPixelB^;
        GCenter := lpPixelG^;
        RCenter := lpPixelR^;

        if (RCenter = CIntervalRed)
          then {SetPixel(hWorkDC, IW, IL,Color8)  }
        begin WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(Image)^[WherePixel];
          lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
          lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 239; end

        else if (GCenter = CIntervalGreen)
          then { SetPixel(hWorkDC, IW, IL,Color3)}
        begin WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(Image)^[WherePixel];
          lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
          lpPixelB^ := 0; lpPixelG^ := 239; lpPixelR^ := 0; end

        else if (BCenter = CIntervalBlue)
          then {SetPixel(hWorkDC, IW, IL,Color1)}
        begin WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(Image)^[WherePixel];
          lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
          lpPixelB^ := 239; lpPixelG^ := 0; lpPixelR^ := 0; end

        else begin
          for sY := 0 to (HowMany - 1) do begin
            for sX := 0 to (HowMany - 1) do begin
        { TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
              WherePixel := (3 * (IW + (sX + Where))) + (BytesPerLine
                * (((IL + sY + Where))));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueColor := lpPixelB^;
              GreenColor := lpPixelG^;
              RedColor := lpPixelR^;

         {Do not do the center ... it would be one
         and mess with the total, and the Center = 1 stuff}

{         IF ((sX+Where <> 0) AND (sY+Where<>0)) Then}
              if (sX <> Center) and (sY <> Center) then
              begin
                if ((RCenter < CIntervalRed) and (RedColor >
                  CIntervalRed))
                  then {SetPixel(hWorkDC, IW, IL,Color8)}
                begin
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 239;
                end
                else if ((RCenter > CIntervalRed) and (RedColor <
                  CIntervalRed))
                  then {SetPixel(hWorkDC, IW, IL,Color8)}
                begin
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 239;
                end

                else if ((GCenter < CIntervalGreen) and (GreenColor >
                  CIntervalGreen))
                  then {SetPixel(hWorkDC, IW, IL,Color3) }
                begin
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 0; lpPixelG^ := 239; lpPixelR^ := 0;
                end

                else if ((GCenter > CIntervalGreen) and (GreenColor <
                  CIntervalGreen))
                  then {SetPixel(hWorkDC, IW, IL,Color3) }
                begin
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 0; lpPixelG^ := 239; lpPixelR^ := 0;
                end

                else if ((BCenter < CIntervalBlue) and (BlueColor >
                  CIntervalBlue))
                  then {SetPixel(hWorkDC, IW, IL,Color1) }
                begin
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 239; lpPixelG^ := 0; lpPixelR^ := 0;
                end

                else if ((BCenter > CIntervalBlue) and (BlueColor <
                  CIntervalBlue))
                  then {SetPixel(hWorkDC, IW, IL,Color1) }
                begin
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 239; lpPixelG^ := 0; lpPixelR^ := 0;
                end

                else {SetPixel(hWorkDC, IW, IL,ColorWhite)}
                begin
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 255; lpPixelG^ := 255; lpPixelR^ :=
                  255;
                end;
              end; {of If Center}
            end; {SX   Filter Width}
          end; {SY   Filter Length}
        end; {of Center}

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    BlackOut;
    SetImage;
{IF (DeleteBitmap <> TRUE) THEN Do_Error(1231,1229);}
  end; {OF MAKE BITMAP}
end; {of Acontour line # xyz}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure Do_Contour(CIntervalRed, CIntervalGreen, CIntervalBlue:
  Integer); {Do_RGBContour;}
var
  R_Filtered, G_Filtered, B_Filtered: Double;
  R_Hope, G_Hope, B_Hope, TheColor: Longint;
  RedA, BlueA, GreenA,
    RedB, BlueB, GreenB,
    RedC, BlueC, GreenC,
    RedD, BlueD, GreenD,
    RedE, BlueE, GreenE,
    RedF, BlueF, GreenF,
    RedG, BlueG, GreenG,
    RedH, BlueH, GreenH,
    RedI, BlueI, GreenI: Byte;
  Sx, Sy, ILStart, ILEnd, IWStart, IWEnd: Integer;
  IL, IW: Dword;
begin {Get current Window DC}
  ILStart := (1);
  IWStart := (1);
  ILEnd := (ImageHeight - 1);
  IWEnd := (ImageWidth - 1);
  MakeImage;
  if (ImageMade = TRUE) then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
{A,B,C}
         {TheColor:= GetPixel(hUnDoDC,IW-1,IL+1);
         RedA:= GetRValue(TheColor);
         BlueA:= GetBValue(TheColor);
         GreenA:= GetGValue(TheColor); }
        WherePixel := (3 * (IW - 1)) + (BytesPerLine * (((IL + 1))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueA := lpPixelB^;
        GreenA := lpPixelG^;
        RedA := lpPixelR^;

      {   TheColor:= GetPixel(hUnDoDC,IW,IL+1);
         RedB:= GetRValue(TheColor);
         BlueB:= GetBValue(TheColor);
         GreenB:= GetGValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL + 1))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueB := lpPixelB^;
        GreenB := lpPixelG^;
        RedB := lpPixelR^;

      {   TheColor:= GetPixel(hUnDoDC,IW+1,IL+1);
         RedC:= GetRValue(TheColor);
         BlueC:= GetBValue(TheColor);
         GreenC:= GetGValue(TheColor);}
        WherePixel := (3 * (IW + 1)) + (BytesPerLine * (((IL + 1))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueC := lpPixelB^;
        GreenC := lpPixelG^;
        RedC := lpPixelR^;

{D,E,F}
      {   TheColor:= GetPixel(hUnDoDC,IW-1,IL);
         RedD:= GetRValue(TheColor);
         BlueD:= GetBValue(TheColor);
         GreenD:= GetGValue(TheColor); }
        WherePixel := (3 * (IW - 1)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueD := lpPixelB^;
        GreenD := lpPixelG^;
        RedD := lpPixelR^;

       {  TheColor:= GetPixel(hUnDoDC,IW,IL);
         RedE:= GetRValue(TheColor);
         BlueE:= GetBValue(TheColor);
         GreenE:= GetGValue(TheColor);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueE := lpPixelB^;
        GreenE := lpPixelG^;
        RedE := lpPixelR^;

       {  TheColor:= GetPixel(hUnDoDC,IW+1,IL);
         RedF:= GetRValue(TheColor);
         BlueF:= GetBValue(TheColor);
         GreenF:= GetGValue(TheColor);}
        WherePixel := (3 * (IW + 1)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueF := lpPixelB^;
        GreenF := lpPixelG^;
        RedF := lpPixelR^;

{G,H,I}
{         TheColor:= GetPixel(hUnDoDC,IW-1,IL-1);
         RedG:= GetRValue(TheColor);
         BlueG:= GetBValue(TheColor);
         GreenG:= GetGValue(TheColor);}
        WherePixel := (3 * (IW - 1)) + (BytesPerLine * (((IL - 1))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueG := lpPixelB^;
        GreenG := lpPixelG^;
        RedG := lpPixelR^;

       {  TheColor:= GetPixel(hUnDoDC,IW,IL-1);
         RedH:= GetRValue(TheColor);
         BlueH:= GetBValue(TheColor);
         GreenH:= GetGValue(TheColor);  }
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL - 1))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueH := lpPixelB^;
        GreenH := lpPixelG^;
        RedH := lpPixelR^;

       { TheColor:= GetPixel(hUnDoDC,IW+1,IL-1);
         RedI:= GetRValue(TheColor);
         BlueI:= GetBValue(TheColor);
         GreenI:= GetGValue(TheColor);}
        WherePixel := (3 * (IW + 1)) + (BytesPerLine * (((IL - 1))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueI := lpPixelB^;
        GreenI := lpPixelG^;
        RedI := lpPixelR^;

        if (RedE = CIntervalRed) then
          {SetPixel(hWorkDC, IW, IL,Color8)}
        begin
          WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(Image)^[WherePixel];
          lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
          lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 239;
        end
        else if ((RedE < CIntervalRed) and (RedA > CIntervalRed))
          or ((RedE < CIntervalRed) and (RedB > CIntervalRed))
          or ((RedE < CIntervalRed) and (RedC > CIntervalRed))
          or ((RedE < CIntervalRed) and (RedD > CIntervalRed))
          or ((RedE < CIntervalRed) and (RedF > CIntervalRed))
          or ((RedE < CIntervalRed) and (RedG > CIntervalRed))
          or ((RedE < CIntervalRed) and (RedH > CIntervalRed))
          or ((RedE < CIntervalRed) and (RedI > CIntervalRed))
          then { SetPixel(hWorkDC, IW, IL,Color8)  }
        begin
          WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(Image)^[WherePixel];
          lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
          lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 239;
        end
        else if ((RedE > CIntervalRed) and (RedA < CIntervalRed))
          or ((RedE > CIntervalRed) and (RedB < CIntervalRed))
          or ((RedE > CIntervalRed) and (RedC < CIntervalRed))
          or ((RedE > CIntervalRed) and (RedD < CIntervalRed))
          or ((RedE > CIntervalRed) and (RedF < CIntervalRed))
          or ((RedE > CIntervalRed) and (RedG < CIntervalRed))
          or ((RedE > CIntervalRed) and (RedH < CIntervalRed))
          or ((RedE > CIntervalRed) and (RedI < CIntervalRed))
          then { SetPixel(hWorkDC, IW, IL,Color8)}
        begin
          WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(Image)^[WherePixel];
          lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
          lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := 239;
        end
        else
          if (GreenE = CIntervalGreen) then
            {SetPixel(hWorkDC, IW, IL,Color3)}
          begin
            WherePixel := ((IW * 3) + (IL * BytesPerLine));
            lpPixelB := @PHugeByteArray(Image)^[WherePixel];
            lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
            lpPixelB^ := 0; lpPixelG^ := 239; lpPixelR^ := 0;
          end

          else if ((GreenE < CIntervalGreen) and (GreenA >
            CIntervalGreen))
            or ((GreenE < CIntervalGreen) and (GreenB >
            CIntervalGreen))
            or ((GreenE < CIntervalGreen) and (GreenC >
            CIntervalGreen))
            or ((GreenE < CIntervalGreen) and (GreenD >
            CIntervalGreen))
            or ((GreenE < CIntervalGreen) and (GreenF >
            CIntervalGreen))
            or ((GreenE < CIntervalGreen) and (GreenG >
            CIntervalGreen))
            or ((GreenE < CIntervalGreen) and (GreenH >
            CIntervalGreen))
            or ((GreenE < CIntervalGreen) and (GreenI >
            CIntervalGreen))
            then { SetPixel(hWorkDC, IW, IL,Color3)}
          begin
            WherePixel := ((IW * 3) + (IL * BytesPerLine));
            lpPixelB := @PHugeByteArray(Image)^[WherePixel];
            lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
            lpPixelB^ := 0; lpPixelG^ := 239; lpPixelR^ := 0;
          end
          else if ((GreenE > CIntervalGreen) and (GreenA <
            CIntervalGreen))
            or ((GreenE > CIntervalGreen) and (GreenB <
            CIntervalGreen))
            or ((GreenE > CIntervalGreen) and (GreenC <
            CIntervalGreen))
            or ((GreenE > CIntervalGreen) and (GreenD <
            CIntervalGreen))
            or ((GreenE > CIntervalGreen) and (GreenF <
            CIntervalGreen))
            or ((GreenE > CIntervalGreen) and (GreenG <
            CIntervalGreen))
            or ((GreenE > CIntervalGreen) and (GreenH <
            CIntervalGreen))
            or ((GreenE > CIntervalGreen) and (GreenI <
            CIntervalGreen))
            then {SetPixel(hWorkDC, IW, IL,Color3)}
          begin
            WherePixel := ((IW * 3) + (IL * BytesPerLine));
            lpPixelB := @PHugeByteArray(Image)^[WherePixel];
            lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
            lpPixelB^ := 0; lpPixelG^ := 239; lpPixelR^ := 0;
          end

          else
            if (BlueE = CIntervalBlue) then
              {SetPixel(hWorkDC, IW, IL,Color1)}
            begin
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := 239; lpPixelG^ := 0; lpPixelR^ := 0;
            end

            else if ((BlueE < CIntervalBlue) and (BlueA >
              CIntervalBlue))
              or ((BlueE < CIntervalBlue) and (BlueB > CIntervalBlue))
              or ((BlueE < CIntervalBlue) and (BlueC > CIntervalBlue))
              or ((BlueE < CIntervalBlue) and (BlueD > CIntervalBlue))
              or ((BlueE < CIntervalBlue) and (BlueF > CIntervalBlue))
              or ((BlueE < CIntervalBlue) and (BlueG > CIntervalBlue))
              or ((BlueE < CIntervalBlue) and (BlueH > CIntervalBlue))
              or ((BlueE < CIntervalBlue) and (BlueI > CIntervalBlue))
              then {SetPixel(hWorkDC, IW, IL,Color1) }
            begin
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := 239; lpPixelG^ := 0; lpPixelR^ := 0;
            end

            else if ((BlueE > CIntervalBlue) and (BlueA <
              CIntervalBlue))
              or ((BlueE > CIntervalBlue) and (BlueB < CIntervalBlue))
              or ((BlueE > CIntervalBlue) and (BlueC < CIntervalBlue))
              or ((BlueE > CIntervalBlue) and (BlueD < CIntervalBlue))
              or ((BlueE > CIntervalBlue) and (BlueF < CIntervalBlue))
              or ((BlueE > CIntervalBlue) and (BlueG < CIntervalBlue))
              or ((BlueE > CIntervalBlue) and (BlueH < CIntervalBlue))
              or ((BlueE > CIntervalBlue) and (BlueI < CIntervalBlue))
              then {SetPixel(hWorkDC, IW, IL,Color1)}
            begin
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := 239; lpPixelG^ := 0; lpPixelR^ := 0;
            end

            else {SetPixel(hWorkDC, IW, IL,ColorWhite)}
            begin
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := 255; lpPixelG^ := 255; lpPixelR^ := 255;
            end

{Pixels overwritten (previously taken) by R,G or B
  can be somewhat remedied by setting different CInterval
  or by setting CI for R,G to 0 and B to whatever}
{Wide areas or wide lines of pixels caused by two pixels meeting the
  1 is > and the other is < is fixed? by
  IF ((ABS(RedE-CInterval) < ABS(BlueA..BlueI - CInterval)) then setpixel}
{ANOTHER way is to get the Center pixel then compare the outside pixels
in a filter type loop}{See Ratboy as an example of code}
      end; {OF WIDTH}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {OF LENGTH}
{BlackOut;}
    SetImage;
{IF (DeleteBitmap <> TRUE) THEN Do_Error(1231,1229);}
  end; {OF MAKE BITMAP}
end;
{WIDE}
{---------------------------------------------------------------------}

procedure Do_Measured; {Called from Mouse}
var
  MeanderDistance, Code: Integer;
  InDistanceS: string;
begin
  DistanceForm := TDistanceForm.Create(Application);
  if DistanceForm.ShowModal = mrOK then
  begin
    InDistanceS := DistanceForm.DistanceEdit.Text;
    Val(InDistanceS, InDistance, Code);
    InDistanceS := DistanceForm.DOEdit.Text;
    Val(InDistanceS, MeanderDistance, Code);
    if LoggingToMacro then
    begin
      MacroForm.MacroRE.Lines.Add('=0159  Do_Measured_Do');
      MacroForm.MacroRE.Lines.Add(IntToStr(InDistance));
      MacroForm.MacroRE.Lines.Add(IntToStr(PixelLine));
      MacroForm.MacroRE.Lines.Add(IntToStr(MeanderDistance));
    end;
    if LoggingToDIP then
    begin
      PBands.DIPMemo.Lines.Add('=0159  Do_Measured_Do');
      PBands.DIPMemo.Lines.Add(IntToStr(InDistance));
      PBands.DIPMemo.Lines.Add(IntToStr(PixelLine));
      PBands.DIPMemo.Lines.Add(IntToStr(MeanderDistance));
      PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
      PBands.DIPSaveIt;
    end;
    Do_Measured_Do(InDistance, PixelLine, MeanderDistance);
  end;
  DistanceForm.Free;
end;

procedure Do_Measured_Do(InDistance,
                         PixelLine, MeanderDistance:Integer);
var
{  TheColor: Longint;
  RedC, BlueC, GreenC,
    RedColorC, BlueColorC, GreenColorC,
    RedColorCM, BlueColorCM, GreenColorCM,
    RedColorC2, BlueColorC2, GreenColorC2,
    RedColor, BlueColor, GreenColor: Byte;
  Code,
    R_Count, G_Count, B_Count,
    IMean,Backside,}
     PPM,  KBScale,
    ILStart, ILEnd, IWStart, IWEnd: Integer;
{  R_Array, G_Array, B_Array: T_Array; }
  PPMCounter, IL, IW: DWord;
begin {Get current Window DC}
  KBScale := (InDistance div PixelLine);
{Scale =  Length / Number of pixels}{?Scale = Number of pixels / Length}
{This is 1:7  1 pixel = 7 feet}{?KBScale:=(PixelLine /InDistance);}
{1,100 / 157 = 7 feet per pixel}{?This gives 1/KBScale = 7}
{11,000 / 157 = 70 feet}{feet per pixel}
{MeanderDistance:= 200; }{Get user size or have a constant?}
{Pixels per meander (200/7=29)}

  PPM := (MeanderDistance div KBScale);
  PPMCounter := (PPM div 2);
{Roads are obstacles
Asphalt 2 lane: 18'
Concrete 2 lane: 22'
Concrete 3lanes+2sides=5*11' = 55' per side of divided highway
}
  ILStart := 0;
  ILEnd := (ImageHeight)-2;
  IWStart := 0 + PPMCounter;
  IWEnd := (ImageWidth - (PPMCounter))-2;
  MakeImage;
  if (ImageMade = TRUE) then begin
{    showmessage('PPM'+inttostr(PPM)
    +' IWStart '+inttostr(IWStart)+' IWEnd '+inttostr(IWEnd));}

    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
(*
        R_Count := 1;
        G_Count := 1;
        B_Count := 1;

        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
{      BlueColorC  := lpPixelB^;
      GreenColorC := lpPixelG^;}
        RedColorC := lpPixelR^;

        for IMean := 0 to PPM do begin
{    TheColor:= GetPixel(hUnDoDC,(IW-PPMCounter),(IL));
    RedColorCM:= GetRValue(TheColor);
    GreenColorCM:= GetGValue(TheColor);
    BlueColorCM:= GetBValue(TheColor);}
          WherePixel := (3 * (IW - PPMCounter))
                       + (BytesPerLine * IL);
                      { + (BytesPerLine * (((IL))));}
          lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
          lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
          BlueColorCM := lpPixelB^;
          GreenColorCM := lpPixelG^;
          RedColorCM := lpPixelR^;

    {DO the stuff}
          R_Array[R_Count] := RedColorCM; Inc(R_Count);
          G_Array[G_Count] := GreenColorCM; Inc(G_Count);
          B_Array[B_Count] := BlueColorCM; Inc(B_Count);
        end; {of IMean}
        { SortItQuick(Direction : String ; Count : Integer ; Var Item : Freq);}
        Dec(R_Count);
        Dec(G_Count);
        Dec(B_Count);
        SortItQuick('UP', R_Count, R_Array);
        SortItQuick('UP', G_Count, G_Array);
        SortItQuick('UP', B_Count, B_Array);
        RedColor := 0;
        GreenColor := 0;
        BlueColor := 0;
        if (R_Array[R_Count] = RedColorC) then RedColor := 250;
        if ((B_Array[1] < 120) and (B_Array[B_Count] > 60)) then
          BlueColor := 250;
         {If (B_Array[B_Count] <70) then BlueColor :=200;}
        WherePixel := ((IW * 3) + (IL * BytesPerLine));
        lpPixelB := @PHugeByteArray(Image)^[WherePixel];
        lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
        lpPixelB^ := BlueColor; lpPixelG^ := GreenColor; lpPixelR^ :=
        RedColor;
{SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));            }
*)
(*begin
    For Backside := 1 to PPMCounter DO begin
    TheColor:= GetPixel(hUnDoDC,(IW-Backside),(IL));
    RedColorC2:= GetRValue(TheColor);
    IF (RedColorC2 > RedColorC) then RedColor := 250;
    RedColorC := RedColorC2;
    End;
    For Backside := 1 to PPMCounter DO begin
    TheColor:= GetPixel(hUnDoDC,(IW+Backside),(IL));
    RedColorC2:= GetRValue(TheColor);
    IF (RedColorC2 < RedColorC) then RedColor := 250;
    RedColorC := RedColorC2;
    End;
End; {of (R_Array[R_Count] = RedColorC)}
*)
      end; {of  Image Width}
      Per_Done := Round(100 * ((IL+1) / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    {showmessage('here 3'); }
    SetImage;
{IF (DeleteBitmap <> TRUE) THEN  Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{Line Profile is its own thing}
{---------------------------------------------------------------------}

procedure DoSnake(InX, InY: Integer; Colors: TColor);
var BlueCS, RedCS, GreenCS: string;
  BlueC, RedC, GreenC: Byte;
begin
{Get the color at the point and input it into the Follower}
  BlueC := GetBValue(Colors); Str(BlueC, BlueCS);
  RedC := GetRValue(Colors); Str(RedC, RedCS);
  GreenC := GetGValue(Colors); Str(GreenC, GreenCS);

  LinearForm.EdgeFollowEdit.Text := GreenCS;

{Case LinearForm.LinearRG.ItemIndex of
0:LinearForm.EdgeFollowEdit.Text:=RedCS;
1:LinearForm.EdgeFollowEdit.Text:=GreenCS;
2:LinearForm.EdgeFollowEdit.Text:=BlueCS;
end;}{Case}
end;
{---------------------------------------------------------------------}

procedure Do_EdgeFollow(CIntervalRed: integer);
var
  path: Boolean;
  Redder, Moonwalker,
    RedSW, BlueSW, GreenSW,
    RedS, BlueS, GreenS,
    RedSE, BlueSE, GreenSE,
    RedW, BlueW, GreenW,
    RedX, BlueX, GreenX,
    RedE, BlueE, GreenE,
    RedNW, BlueNW, GreenNW,
    RedN, BlueN, GreenN,
    RedNE, BlueNE, GreenNE: Byte;
  ILStart, ILEnd, IWStart, IWEnd: Integer;
  IOIL, IOIW, IL, IW: Dword;
  TheColor: Longint;
  M_Count: Double;
begin {Get current Window DC}
{GetNibbler;What value to search for.. along}
  ILStart := (1);
  IWStart := (1);
  ILEnd := (ImageHeight - 1);
  IWEnd := (ImageWidth - 1);
  MakeImage;
  if (ImageMade = TRUE) then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
{Working ONLY with Green locators, RED markers...}
{Do R,G,B then combine... IF any are 255 then ALL are 255}
      {   TheColor:= GetPixel(hWorkDC,IW,IL);
         RedX:= GetRValue(TheColor);
         BlueX:= GetBValue(TheColor);
         GreenX:= GetGValue(TheColor); }
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueX := lpPixelB^;
        GreenX := lpPixelG^;
        RedX := lpPixelR^;

        if ((GreenX = CIntervalRed)
          {and (GreenColor=255) and(BlueColor=255)})
          then begin {Search for adjoining  meanders}
          M_Count := 1;
          IOIW := IW; IOIL := IL;
          path := True;
          Moonwalker := 255;
{Greener:=255;}
          while (path) do begin
{SW,S,SE}
{         TheColor:= GetPixel(hWorkDC,IOIW-1,IOIL+1);
         RedSW:= GetRValue(TheColor);
         BlueSW:= GetBValue(TheColor);
         GreenSW:= GetGValue(TheColor);}
            WherePixel := ((3 * (IOIW - 1)) + (BytesPerLine * (IOIL +
              1)));
            lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
            lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
            BlueSW := lpPixelB^;
            GreenSW := lpPixelG^;
            RedSW := lpPixelR^;

{         TheColor:= GetPixel(hWorkDC,IOIW,IOIL+1);
         RedS:= GetRValue(TheColor);
         BlueS:= GetBValue(TheColor);
         GreenS:= GetGValue(TheColor); }
            WherePixel := ((3 * (IOIW)) + (BytesPerLine * (IOIL +
              1)));
            lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
            lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
            BlueS := lpPixelB^;
            GreenS := lpPixelG^;
            RedS := lpPixelR^;

       {  TheColor:= GetPixel(hWorkDC,IOIW+1,IOIL+1);
         RedSE:= GetRValue(TheColor);
         BlueSE:= GetBValue(TheColor);
         GreenSE:= GetGValue(TheColor); }
            WherePixel := ((3 * (IOIW + 1)) + (BytesPerLine * (IOIL +
              1)));
            lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
            lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
            BlueSE := lpPixelB^;
            GreenSE := lpPixelG^;
            RedSE := lpPixelR^;

{W,X,E}
        { TheColor:= GetPixel(hWorkDC,IOIW-1,IOIL);
         RedW:= GetRValue(TheColor);
         BlueW:= GetBValue(TheColor);
         GreenW:= GetGValue(TheColor); }
            WherePixel := ((3 * (IOIW - 1)) + (BytesPerLine *
              (IOIL)));
            lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
            lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
            BlueW := lpPixelB^;
            GreenW := lpPixelG^;
            RedW := lpPixelR^;

       {  TheColor:= GetPixel(hWorkDC,IOIW,IOIL);
         RedX:= GetRValue(TheColor);
         BlueX:= GetBValue(TheColor);
         GreenX:= GetGValue(TheColor);}
            WherePixel := ((3 * (IOIW)) + (BytesPerLine * (IOIL)));
            lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
            lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
            BlueX := lpPixelB^;
            GreenX := lpPixelG^;
            RedX := lpPixelR^;

      {   TheColor:= GetPixel(hWorkDC,IOIW+1,IOIL);
         RedE:= GetRValue(TheColor);
         BlueE:= GetBValue(TheColor);
         GreenE:= GetGValue(TheColor); }
            WherePixel := ((3 * (IOIW + 1)) + (BytesPerLine *
              (IOIL)));
            lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
            lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
            BlueE := lpPixelB^;
            GreenE := lpPixelG^;
            RedE := lpPixelR^;

{NW,N,NE}
        { TheColor:= GetPixel(hWorkDC,IOIW-1,IOIL-1);
         RedNW:= GetRValue(TheColor);
         BlueNW:= GetBValue(TheColor);
         GreenNW:= GetGValue(TheColor); }
            WherePixel := ((3 * (IOIW - 1)) + (BytesPerLine * (IOIL -
              1)));
            lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
            lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
            BlueNW := lpPixelB^;
            GreenNW := lpPixelG^;
            RedNW := lpPixelR^;

       {  TheColor:= GetPixel(hWorkDC,IOIW,IOIL-1);
         RedN:= GetRValue(TheColor);
         BlueN:= GetBValue(TheColor);
         GreenN:= GetGValue(TheColor); }
            WherePixel := ((3 * (IOIW)) + (BytesPerLine * (IOIL -
              1)));
            lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
            lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
            BlueN := lpPixelB^;
            GreenN := lpPixelG^;
            RedN := lpPixelR^;

{         TheColor:= GetPixel(hWorkDC,IOIW+1,IOIL-1);
         RedNE:= GetRValue(TheColor);
         BlueNE:= GetBValue(TheColor);
         GreenNE:= GetGValue(TheColor);}
            WherePixel := ((3 * (IOIW + 1)) + (BytesPerLine * (IOIL -
              1)));
            lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
            lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
            BlueNE := lpPixelB^;
            GreenNE := lpPixelG^;
            RedNE := lpPixelR^;

{Down}
            if ((GreenX = GreenS)
              and (GreenX <> GreenSE) and (MoonWalker <> GreenSE))
              then
            begin IOIW := IOIW; IOIL := IOIL + 1;
              M_Count := M_Count + 1;
{   SetPixel(hWorkDC, IOIW, IOIL-1,RGB(0,MoonWalker,0));}
              WherePixel := ((IOIW * 3) + ((IOIL - 1) *
                BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := 0; lpPixelG^ := MoonWalker; lpPixelR^ :=
              0;
              path := True;
            end else
{DLeft}
              if ((GreenX = GreenS) and (GreenX = GreenSW)
                and (GreenX <> GreenE) and (GreenX <> GreenSE)
                and (MoonWalker <> GreenE) and (MoonWalker <>
                GreenSE))
                then begin IOIW := IOIW; IOIL := IOIL + 1;
                M_Count := M_Count + 1;
{   SetPixel(hWorkDC, IOIW, IOIL-1,RGB(0,MoonWalker,0));}
                WherePixel := ((IOIW * 3) + ((IOIL - 1) *
                  BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := 0; lpPixelG^ := MoonWalker; lpPixelR^ :=
                0;
                path := True
              end else
{DIL}
                if ((GreenX = GreenSW)
                  and (GreenX <> GreenE) and (GreenX <> GreenSE) and
                  (GreenX <> GreenS)
                  and (MoonWalker <> GreenE) and (MoonWalker <>
                  GreenSE) and (MoonWalker <> GreenS))
                  then begin IOIW := IOIW - 1; IOIL := IOIL + 1;
                  M_Count := M_Count + 1.5;
{   SetPixel(hWorkDC, IOIW+1, IOIL-1,RGB(0,MoonWalker,0));}
                  WherePixel := (((IOIW + 1) * 3) + ((IOIL - 1) *
                    BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 0; lpPixelG^ := MoonWalker; lpPixelR^
                  := 0;
                  path := True
                end else
{Left}
                  if ((GreenX = GreenW) and (MoonWalker = GreenN)
                    and (GreenX <> GreenE) and (MoonWalker <> GreenE)
                    and (GreenX <> GreenSE) and (GreenX <> GreenS)
                    and (GreenX <> GreenSW)
                    and (MoonWalker <> GreenSE) and (MoonWalker <>
                    GreenS) and (MoonWalker <> GreenSW))
                    then begin IOIW := IOIW - 1; IOIL := IOIL;
                    M_Count := M_Count + 0.5;
   {SetPixel(hWorkDC, IOIW+1, IOIL,RGB(0,MoonWalker,0));}
                    WherePixel := (((IOIW + 1) * 3) + ((IOIL) *
                      BytesPerLine));
                    lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                    lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                      1];
                    lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                      2];
                    lpPixelB^ := 0; lpPixelG^ := MoonWalker; lpPixelR^
                    := 0;
                    path := True
                  end else
{ONL}
                    if ((GreenX = GreenW) and (GreenE = MoonWalker)
                      and (GreenX <> GreenSE) and (GreenX <> GreenS)
                      and (GreenX <> GreenSW)
                      and (MoonWalker <> GreenSE) and (MoonWalker <>
                      GreenS) and (MoonWalker <> GreenSW))
                      then begin IOIW := IOIW - 1; IOIL := IOIL;
                      M_Count := M_Count + 0.5;
   {SetPixel(hWorkDC, IOIW+1, IOIL,RGB(0,MoonWalker,0));}
                      WherePixel := (((IOIW + 1) * 3) + ((IOIL) *
                        BytesPerLine));
                      lpPixelB :=
                        @PHugeByteArray(Image)^[WherePixel];
                      lpPixelG := @PHugeByteArray(Image)^[WherePixel
                        + 1];
                      lpPixelR := @PHugeByteArray(Image)^[WherePixel
                        + 2];
                      lpPixelB^ := 0; lpPixelG^ := MoonWalker;
                      lpPixelR^ := 0;
                      path := True
                    end else
{DIR}
                      if ((GreenX = GreenSE) and (GreenX <> GreenE)
                        and (MoonWalker <> GreenE)) then
                      begin IOIW := IOIW + 1; IOIL := IOIL + 1;
                        M_Count := M_Count + 1.5;
   {SetPixel(hWorkDC, IOIW-1, IOIL-1,RGB(0,MoonWalker,0));}
                        WherePixel := (((IOIW - 1) * 3) + ((IOIL - 1)
                          * BytesPerLine));
                        lpPixelB :=
                          @PHugeByteArray(Image)^[WherePixel];
                        lpPixelG := @PHugeByteArray(Image)^[WherePixel
                          + 1];
                        lpPixelR := @PHugeByteArray(Image)^[WherePixel
                          + 2];
                        lpPixelB^ := 0; lpPixelG^ := MoonWalker;
                        lpPixelR^ := 0;
                        path := True
                      end else
{DZR}
                        if ((GreenX = GreenSE) and (GreenW =
                          MoonWalker)
                          and (GreenX <> GreenE) and (GreenX <>
                          GreenN) and (GreenX <> GreenNE)
                          and (MoonWalker <> GreenE) and (MoonWalker
                          <> GreenN) and (MoonWalker <> GreenNE))
                          then
                        begin IOIW := IOIW + 1; IOIL := IOIL + 1;
                          M_Count := M_Count + 1.5;
   {SetPixel(hWorkDC, IOIW-1, IOIL-1,RGB(0,MoonWalker,0));}
                          WherePixel := (((IOIW - 1) * 3) + ((IOIL -
                            1) * BytesPerLine));
                          lpPixelB :=
                            @PHugeByteArray(Image)^[WherePixel];
                          lpPixelG :=
                            @PHugeByteArray(Image)^[WherePixel + 1];
                          lpPixelR :=
                            @PHugeByteArray(Image)^[WherePixel + 2];
                          lpPixelB^ := 0; lpPixelG^ := MoonWalker;
                          lpPixelR^ := 0;
                          path := True
                        end else
{DRN}
                          if ((GreenX = GreenE) and (GreenNW =
                            MoonWalker)
                            and (GreenX <> GreenN) and (GreenX <>
                            GreenNE)
                            and (MoonWalker <> GreenN) and (MoonWalker
                            <> GreenNE)) then
                          begin IOIW := IOIW + 1; IOIL := IOIL;
                            M_Count := M_Count + 0.5;
{   SetPixel(hWorkDC, IOIW-1, IOIL,RGB(0,MoonWalker,0));  }
                            WherePixel := (((IOIW - 1) * 3) + ((IOIL)
                              * BytesPerLine));
                            lpPixelB :=
                              @PHugeByteArray(Image)^[WherePixel];
                            lpPixelG :=
                              @PHugeByteArray(Image)^[WherePixel +
                                1];
                            lpPixelR :=
                              @PHugeByteArray(Image)^[WherePixel +
                                2];
                            lpPixelB^ := 0; lpPixelG^ := MoonWalker;
                            lpPixelR^ := 0;
                            path := True
                          end else
{DRight}
                            if ((GreenX = GreenS) and (GreenX =
                              GreenSE)
                              and (GreenX <> GreenE) and (MoonWalker
                              <> GreenE)) then
                            begin IOIW := IOIW; IOIL := IOIL + 1;
                              M_Count := M_Count + 1; ;
   {SetPixel(hWorkDC, IOIW, IOIL-1,RGB(0,MoonWalker,0));}
                              WherePixel := (((IOIW) * 3) + ((IOIL -
                                1) * BytesPerLine));
                              lpPixelB :=
                                @PHugeByteArray(Image)^[WherePixel];
                              lpPixelG :=
                                @PHugeByteArray(Image)^[WherePixel +
                                1];
                              lpPixelR :=
                                @PHugeByteArray(Image)^[WherePixel +
                                2];
                              lpPixelB^ := 0; lpPixelG^ :=
                              MoonWalker; lpPixelR^ := 0;
                              path := True
                            end else
{Right}
                              if ((GreenX = GreenE) and (GreenN =
                                MoonWalker)
                                and (GreenX <> GreenNE) and
                                (MoonWalker <> GreenNE)) then
                              begin IOIW := IOIW + 1; IOIL := IOIL;
                                M_Count := M_Count + 0.5;
{   SetPixel(hWorkDC, IOIW-1, IOIL,RGB(0,MoonWalker,0));  }
                                WherePixel := (((IOIW - 1) * 3) +
                                  ((IOIL) * BytesPerLine));
                                lpPixelB :=
                                  @PHugeByteArray(Image)^[WherePixel];
                                lpPixelG :=
                                  @PHugeByteArray(Image)^[WherePixel
                                    +
                                  1];
                                lpPixelR :=
                                  @PHugeByteArray(Image)^[WherePixel
                                    +
                                  2];
                                lpPixelB^ := 0; lpPixelG^ :=
                                MoonWalker; lpPixelR^ := 0;
                                path := True
                              end else
{On Right}
                                if ((GreenX = GreenE) and (GreenW =
                                  MoonWalker)
                                  and (GreenX <> GreenNE) and (GreenX
                                  <> GreenN)
                                  and (MoonWalker <> GreenNE) and
                                  (MoonWalker <> GreenN)) then
                                begin IOIW := IOIW + 1; IOIL := IOIL;
                                  M_Count := M_Count + 0.5;
   {SetPixel(hWorkDC, IOIW-1, IOIL,RGB(0,MoonWalker,0));}
                                  WherePixel := (((IOIW - 1) * 3) +
                                    ((IOIL) * BytesPerLine));
                                  lpPixelB :=
                                    @PHugeByteArray(Image)^[WherePixel];
                                  lpPixelG :=
                                    @PHugeByteArray(Image)^[WherePixel
                                    + 1];
                                  lpPixelR :=
                                    @PHugeByteArray(Image)^[WherePixel
                                    + 2];
                                  lpPixelB^ := 0; lpPixelG^ :=
                                  MoonWalker; lpPixelR^ := 0;
                                  path := True
                                end else
{Failed}
                                begin
                                  path := False;
                                end;
          end; {of While path}

          if (M_Count < 30) then
          begin
            Moonwalker := 1; {not 255 anymore}
            M_Count := 1;
            IOIW := IW; IOIL := IL;
            path := True;
            while (path) do begin
{SW,S,SE}
       {  TheColor:= GetPixel(hWorkDC,IOIW-1,IOIL+1);
         RedSW:= GetRValue(TheColor);
         BlueSW:= GetBValue(TheColor);
         GreenSW:= GetGValue(TheColor);}
              WherePixel := ((3 * (IOIW - 1)) + (BytesPerLine * (IOIL
                + 1)));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueSW := lpPixelB^;
              GreenSW := lpPixelG^;
              RedSW := lpPixelR^;

{         TheColor:= GetPixel(hWorkDC,IOIW,IOIL+1);
         RedS:= GetRValue(TheColor);
         BlueS:= GetBValue(TheColor);
         GreenS:= GetGValue(TheColor);   }
              WherePixel := ((3 * (IOIW)) + (BytesPerLine * (IOIL +
                1)));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueS := lpPixelB^;
              GreenS := lpPixelG^;
              RedS := lpPixelR^;

        { TheColor:= GetPixel(hWorkDC,IOIW+1,IOIL+1);
         RedSE:= GetRValue(TheColor);
         BlueSE:= GetBValue(TheColor);
         GreenSE:= GetGValue(TheColor); }
              WherePixel := ((3 * (IOIW + 1)) + (BytesPerLine * (IOIL
                + 1)));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueSE := lpPixelB^;
              GreenSE := lpPixelG^;
              RedSE := lpPixelR^;

{W,X,E}
     {   TheColor:= GetPixel(hWorkDC,IOIW-1,IOIL);
         RedW:= GetRValue(TheColor);
         BlueW:= GetBValue(TheColor);
         GreenW:= GetGValue(TheColor); }
              WherePixel := ((3 * (IOIW - 1)) + (BytesPerLine *
                (IOIL)));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueW := lpPixelB^;
              GreenW := lpPixelG^;
              RedW := lpPixelR^;

    {     TheColor:= GetPixel(hWorkDC,IOIW,IOIL);
         RedX:= GetRValue(TheColor);
         BlueX:= GetBValue(TheColor);
         GreenX:= GetGValue(TheColor);  }
              WherePixel := ((3 * (IOIW)) + (BytesPerLine * (IOIL)));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              GreenX := lpPixelG^;
{      BlueX  := lpPixelB^;
      RedX   := lpPixelR^;}

        { TheColor:= GetPixel(hWorkDC,IOIW+1,IOIL);
         RedE:= GetRValue(TheColor);
         BlueE:= GetBValue(TheColor);
         GreenE:= GetGValue(TheColor); }
              WherePixel := ((3 * (IOIW + 1)) + (BytesPerLine *
                (IOIL)));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueE := lpPixelB^;
              GreenE := lpPixelG^;
              RedE := lpPixelR^;

{NW,N,NE}
        { TheColor:= GetPixel(hWorkDC,IOIW-1,IOIL-1);
         RedNW:= GetRValue(TheColor);
         BlueNW:= GetBValue(TheColor);
         GreenNW:= GetGValue(TheColor);  }
              WherePixel := ((3 * (IOIW - 1)) + (BytesPerLine * (IOIL
                - 1)));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueNW := lpPixelB^;
              GreenNW := lpPixelG^;
              RedNW := lpPixelR^;

       {  TheColor:= GetPixel(hWorkDC,IOIW,IOIL-1);
         RedN:= GetRValue(TheColor);
         BlueN:= GetBValue(TheColor);
         GreenN:= GetGValue(TheColor);  }
              WherePixel := ((3 * (IOIW)) + (BytesPerLine * (IOIL -
                1)));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueN := lpPixelB^;
              GreenN := lpPixelG^;
              RedN := lpPixelR^;

      {   TheColor:= GetPixel(hWorkDC,IOIW+1,IOIL-1);
         RedNE:= GetRValue(TheColor);
         BlueNE:= GetBValue(TheColor);
         GreenNE:= GetGValue(TheColor);     }
              WherePixel := ((3 * (IOIW + 1)) + (BytesPerLine * (IOIL
                - 1)));
              lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
              lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
              BlueNE := lpPixelB^;
              GreenNE := lpPixelG^;
              RedNE := lpPixelR^;

{Down}
              if ((GreenX = GreenS)
                and (GreenX <> GreenSE) and (MoonWalker <> GreenSE))
                then
              begin IOIW := IOIW; IOIL := IOIL + 1;
                M_Count := M_Count + 1;
{   SetPixel(hWorkDC, IOIW, IOIL-1,RGB(0,MoonWalker,0));}
                WherePixel := (((IOIW) * 3) + ((IOIL - 1) *
                  BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := 0; lpPixelG^ := MoonWalker; lpPixelR^ :=
                0;

                path := True
              end else
{DLeft}
                if ((GreenX = GreenS) and (GreenX = GreenSW)
                  and (GreenX <> GreenE) and (GreenX <> GreenSE)
                  and (MoonWalker <> GreenE) and (MoonWalker <>
                  GreenSE))
                  then begin IOIW := IOIW; IOIL := IOIL + 1;
                  M_Count := M_Count + 1;
   {SetPixel(hWorkDC, IOIW, IOIL-1,RGB(0,MoonWalker,0));}
                  WherePixel := (((IOIW) * 3) + ((IOIL - 1) *
                    BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 0; lpPixelG^ := MoonWalker; lpPixelR^
                  := 0;

                  path := True
                end else
{DIL}
                  if ((GreenX = GreenSW)
                    and (GreenX <> GreenE) and (GreenX <> GreenSE)
                    and (GreenX <> GreenS)
                    and (MoonWalker <> GreenE) and (MoonWalker <>
                    GreenSE) and (MoonWalker <> GreenS))
                    then begin IOIW := IOIW - 1; IOIL := IOIL + 1;
                    M_Count := M_Count + 1.5;
{   SetPixel(hWorkDC, IOIW+1, IOIL-1,RGB(0,MoonWalker,0));}
                    WherePixel := (((IOIW + 1) * 3) + ((IOIL - 1) *
                      BytesPerLine));
                    lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                    lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                      1];
                    lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                      2];
                    lpPixelB^ := 0; lpPixelG^ := MoonWalker; lpPixelR^
                    := 0;
                    path := True
                  end else
{Left}
                    if ((GreenX = GreenW) and (MoonWalker = GreenN)
                      and (GreenX <> GreenE) and (MoonWalker <>
                      GreenE)
                      and (GreenX <> GreenSE) and (GreenX <> GreenS)
                      and (GreenX <> GreenSW)
                      and (MoonWalker <> GreenSE) and (MoonWalker <>
                      GreenS) and (MoonWalker <> GreenSW))
                      then begin IOIW := IOIW - 1; IOIL := IOIL;
                      M_Count := M_Count + 0.5;
   {SetPixel(hWorkDC, IOIW+1, IOIL,RGB(0,MoonWalker,0));}
                      WherePixel := (((IOIW + 1) * 3) + ((IOIL) *
                        BytesPerLine));
                      lpPixelB :=
                        @PHugeByteArray(Image)^[WherePixel];
                      lpPixelG := @PHugeByteArray(Image)^[WherePixel
                        + 1];
                      lpPixelR := @PHugeByteArray(Image)^[WherePixel
                        + 2];
                      lpPixelB^ := 0; lpPixelG^ := MoonWalker;
                      lpPixelR^ := 0;
                      path := True
                    end else
{ONL}
                      if ((GreenX = GreenW) and (GreenE = MoonWalker)
                        and (GreenX <> GreenSE) and (GreenX <> GreenS)
                        and (GreenX <> GreenSW)
                        and (MoonWalker <> GreenSE) and (MoonWalker
                        <> GreenS) and (MoonWalker <> GreenSW))
                        then begin IOIW := IOIW - 1; IOIL := IOIL;
                        M_Count := M_Count + 0.5;
   {SetPixel(hWorkDC, IOIW+1, IOIL,RGB(0,MoonWalker,0));}
                        WherePixel := (((IOIW + 1) * 3) + ((IOIL) *
                          BytesPerLine));
                        lpPixelB :=
                          @PHugeByteArray(Image)^[WherePixel];
                        lpPixelG := @PHugeByteArray(Image)^[WherePixel
                          + 1];
                        lpPixelR := @PHugeByteArray(Image)^[WherePixel
                          + 2];
                        lpPixelB^ := 0; lpPixelG^ := MoonWalker;
                        lpPixelR^ := 0;
                        path := True
                      end else
{DIR}
                        if ((GreenX = GreenSE) and (GreenX <> GreenE)
                          and (MoonWalker <> GreenE)) then
                        begin IOIW := IOIW + 1; IOIL := IOIL + 1;
                          M_Count := M_Count + 1.5;
   {SetPixel(hWorkDC, IOIW-1, IOIL-1,RGB(0,MoonWalker,0));}
                          WherePixel := (((IOIW - 1) * 3) + ((IOIL -
                            1) * BytesPerLine));
                          lpPixelB :=
                            @PHugeByteArray(Image)^[WherePixel];
                          lpPixelG :=
                            @PHugeByteArray(Image)^[WherePixel + 1];
                          lpPixelR :=
                            @PHugeByteArray(Image)^[WherePixel + 2];
                          lpPixelB^ := 0; lpPixelG^ := MoonWalker;
                          lpPixelR^ := 0;
                          path := True
                        end else
{DZR}
                          if ((GreenX = GreenSE) and (GreenW =
                            MoonWalker)
                            and (GreenX <> GreenE) and (GreenX <>
                            GreenN) and (GreenX <> GreenNE)
                            and (MoonWalker <> GreenE) and (MoonWalker
                            <> GreenN) and (MoonWalker <> GreenNE))
                            then
                          begin IOIW := IOIW + 1; IOIL := IOIL + 1;
                            M_Count := M_Count + 1.5;
   {SetPixel(hWorkDC, IOIW-1, IOIL-1,RGB(0,MoonWalker,0));}
                            WherePixel := (((IOIW - 1) * 3) + ((IOIL
                              - 1) * BytesPerLine));
                            lpPixelB :=
                              @PHugeByteArray(Image)^[WherePixel];
                            lpPixelG :=
                              @PHugeByteArray(Image)^[WherePixel +
                                1];
                            lpPixelR :=
                              @PHugeByteArray(Image)^[WherePixel +
                                2];
                            lpPixelB^ := 0; lpPixelG^ := MoonWalker;
                            lpPixelR^ := 0;
                            path := True
                          end else
{DRN}
                            if ((GreenX = GreenE) and (GreenNW =
                              MoonWalker)
                              and (GreenX <> GreenN) and (GreenX <>
                              GreenNE)
                              and (MoonWalker <> GreenN) and
                              (MoonWalker <> GreenNE)) then
                            begin IOIW := IOIW + 1; IOIL := IOIL;
                              M_Count := M_Count + 0.5;
   {SetPixel(hWorkDC, IOIW-1, IOIL,RGB(0,MoonWalker,0));}
                              WherePixel := (((IOIW - 1) * 3) +
                                ((IOIL) * BytesPerLine));
                              lpPixelB :=
                                @PHugeByteArray(Image)^[WherePixel];
                              lpPixelG :=
                                @PHugeByteArray(Image)^[WherePixel +
                                1];
                              lpPixelR :=
                                @PHugeByteArray(Image)^[WherePixel +
                                2];
                              lpPixelB^ := 0; lpPixelG^ :=
                              MoonWalker; lpPixelR^ := 0;
                              path := True
                            end else
{DRight}
                              if ((GreenX = GreenS) and (GreenX =
                                GreenSE)
                                and (GreenX <> GreenE) and (MoonWalker
                                <> GreenE)) then
                              begin IOIW := IOIW; IOIL := IOIL + 1;
                                M_Count := M_Count + 1;
   {SetPixel(hWorkDC, IOIW, IOIL-1,RGB(0,MoonWalker,0));}
                                WherePixel := (((IOIW) * 3) + ((IOIL
                                  - 1) * BytesPerLine));
                                lpPixelB :=
                                  @PHugeByteArray(Image)^[WherePixel];
                                lpPixelG :=
                                  @PHugeByteArray(Image)^[WherePixel
                                    +
                                  1];
                                lpPixelR :=
                                  @PHugeByteArray(Image)^[WherePixel
                                    +
                                  2];
                                lpPixelB^ := 0; lpPixelG^ :=
                                MoonWalker; lpPixelR^ := 0;

                                path := True
                              end else
{Right}
                                if ((GreenX = GreenE) and (GreenN =
                                  MoonWalker)
                                  and (GreenX <> GreenNE) and
                                  (MoonWalker <> GreenNE)) then
                                begin IOIW := IOIW + 1; IOIL := IOIL;
                                  M_Count := M_Count + 0.5;
   {SetPixel(hWorkDC, IOIW-1, IOIL,RGB(0,MoonWalker,0));}
                                  WherePixel := (((IOIW - 1) * 3) +
                                    ((IOIL) * BytesPerLine));
                                  lpPixelB :=
                                    @PHugeByteArray(Image)^[WherePixel];
                                  lpPixelG :=
                                    @PHugeByteArray(Image)^[WherePixel
                                    + 1];
                                  lpPixelR :=
                                    @PHugeByteArray(Image)^[WherePixel
                                    + 2];
                                  lpPixelB^ := 0; lpPixelG^ :=
                                  MoonWalker; lpPixelR^ := 0;
                                  path := True
                                end else
{On Right}
                                  if ((GreenX = GreenE) and (GreenW =
                                    MoonWalker)
                                    and (GreenX <> GreenNE) and
                                    (GreenX <> GreenN)
                                    and (MoonWalker <> GreenNE) and
                                    (MoonWalker <> GreenN)) then
                                  begin IOIW := IOIW + 1; IOIL :=
                                    IOIL;
                                    M_Count := M_Count + 0.5;
   {SetPixel(hWorkDC, IOIW-1, IOIL,RGB(0,MoonWalker,0));}
                                    WherePixel := (((IOIW - 1) * 3) +
                                      ((IOIL) * BytesPerLine));
                                    lpPixelB :=
                                      @PHugeByteArray(Image)^[WherePixel];
                                    lpPixelG :=
                                      @PHugeByteArray(Image)^[WherePixel
                                      + 1];
                                    lpPixelR :=
                                      @PHugeByteArray(Image)^[WherePixel
                                      + 2];
                                    lpPixelB^ := 0; lpPixelG^ :=
                                    MoonWalker; lpPixelR^ := 0;
                                    path := True
                                  end else
{Failed}
                                  begin
                                    path := False;
   {SetPixel(hWorkDC, IOIW, IOIL,RGB(0, 0,0));}
                                    WherePixel := (((IOIW) * 3) +
                                      ((IOIL) * BytesPerLine));
                                    lpPixelB :=
                                      @PHugeByteArray(Image)^[WherePixel];
                                    lpPixelG :=
                                      @PHugeByteArray(Image)^[WherePixel
                                      + 1];
                                    lpPixelR :=
                                      @PHugeByteArray(Image)^[WherePixel
                                      + 2];
                                    lpPixelB^ := 0; lpPixelG^ := 0;
                                    lpPixelR^ := 0;

                                  end;
            end; {of While path}
          end {of < 20} else
{If Count > (50?) then mark as a meander}
            if (M_Count > 30) then
            begin
{M_Count := 1;}
{IOIW:= IW;  IOIL:= IL;}
              path := True;
{Redder:=200;}
              while (path) do
              begin
                path := False;
              end;
            end
        end; {of If =MoonWalker}
          {ELSE SetPixel(hWorkDC, IW, IL,ColorWhite);}
      end; {OF WIDTH}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {OF LENGTH}
{BlackOut;}
    SetImage;
{IF (DeleteBitmap <> TRUE) THEN Do_Error(1231,1229);}
  end; {OF MAKE BITMAP}
end;
{MoonWalker}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

{Mask meander areas with other method}
{edge detect sharp changes : obstacles}
{Process for meanders}{what texture responds to meanders}
{1}{FIND MEANDER AREAS}{With interior obstacle areas}
{Grab a section to determine if it goes up-ridge and down-swale meanders}
{Check across for meanders}
       {using MEANDER SIZE to determine validity}
       {and how far to search at a time}
  {?? When to check vertical }
      {When to determine angle of meanders ...
        meanders are curving lines...?}
      {Edge detection of Elated code}
{Start - stop of meanders}
{Determine obstacles: roads, fields, lakes}
{Color meanders; obstacle areas}
       {Color is used as a "code" to mark objects}
{2}{COLOR RIDGE and SWALEs of meanders}
     {Edge detection
       - threshold from JUST the pixels that are meanders}
     { DO NOT get data from obstacle pixels}
     {Obstacle pixels will be pixel-joined after connecting meanders}
{3}{Fill over obstacles}
{4}{Database of meander perimeter}
   {Obstacle objects}
{ CMInspectK_Halley
Can use RGB as 3 layers till finished
    R is Boolean: has been checked
    G is fuzzy what? working?
    B is totaling of values area
Class into 8 classes of 8 qualities
Class into 1 class of 256 qualities }

{---------------------------------------------------------------------}

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure Do_EdgeFlow(CIntervalRed: integer);
var
{Caught:Boolean; }
{CenterPixel, TheColor:Longint;   }
  RCenter: Byte;
{  GCenter, BCenter,
  RedColor, BlueColor, GreenColor: Byte;}
{  ILStart, ILEnd, IWStart, IWEnd,
Looped,LineColor, Size : Integer;  }
 {  Center,Where, sX, sY,} IL, IW: Dword;
begin {Get current Window DC}
{LineColor:=LinearForm.LinearRG.ItemIndex;}
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := 0 to ImageHeight - 1 do begin
      for IW := 0 to ImageWidth - 1 do begin
        {Get the Center Pixel}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
{      BCenter  := lpPixelB^;
      GCenter := lpPixelG^; }
        RCenter := lpPixelR^;
        if ((RCenter mod CIntervalRed) = 0) then
        begin
          WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(Image)^[WherePixel];
          lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
          lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := RCenter;
        end
        else
        begin
          WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(Image)^[WherePixel];
          lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
          lpPixelB^ := 255; lpPixelG^ := 255; lpPixelR^ := 255;
        end;
      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
{BlackOut;}
    SetImage;
{IF (DeleteBitmap <> TRUE) THEN Do_Error(1231,1229);}
  end; {OF MAKE BITMAP}
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure ContourInterval(CIntervalRed: integer);
var
  Caught: Boolean;
  CenterPixel, TheColor: Longint;
  RCenter, GCenter, BCenter,
    RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd,
    Looped, LineColor, Size: Integer;
  Center, Where, sX, sY, IL, IW: Dword;
begin {Get current Window DC}
  LineColor := LinearForm.LinearRG.ItemIndex;
  HowMany := 3; {WhatsMySize(InFilterName);}
  Where := (-Trunc(HowMany / 2)); {-1;}
  Center := (Trunc(HowMany / 2) {+1}); {2;}
     {Begin of Whole Autorange = True... Do Twice}
  ILStart := (0 + (Trunc(HowMany / 2)));
  IWStart := (0 + (Trunc(HowMany / 2)));
  ILEnd := (ImageHeight - ((Trunc(HowMany / 2))));
  IWEnd := (ImageWidth - ((Trunc(HowMany / 2))));
  MakeImage;
  if ImageMade = TRUE then begin
    for IL := ILStart to ILEnd do begin
      for IW := IWStart to IWEnd do begin
        {Get the Center Pixel}
{        CenterPixel := GetPixel(hUnDoDC, IW,IL);
        RCenter:= GetRValue(CenterPixel);
        GCenter:= GetGValue(CenterPixel);
        BCenter:= GetBValue(CenterPixel);}
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BCenter := lpPixelB^;
        GCenter := lpPixelG^;
        RCenter := lpPixelR^;
        Caught := False;
        case LineColor of
          0: begin
              if ((RCenter mod CIntervalRed) = 0) then
              begin
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := 0; lpPixelG^ := 0; lpPixelR^ := RCenter;
                Caught := True;
              end
            end;
          1: begin
              if ((GCenter mod CIntervalRed) = 0) then
              begin
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := 0; lpPixelG^ := GCenter; lpPixelR^ := 0;
                Caught := True;
              end
            end;
          2: begin
              if ((BCenter mod CIntervalRed) = 0) then
              begin WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BCenter; lpPixelG^ := 0; lpPixelR^ := 0;
                Caught := True;
              end
            end;
        end; {Case}
        if (Caught = False) then
        begin
          for Looped := 1 to (255 div CIntervalRed) do begin
            for sY := 0 to (HowMany - 1) do begin
              for sX := 0 to (HowMany - 1) do begin
        { TheColor:= GetPixel(hUnDoDC,
                            (IW+(sX+Where)), (IL+(sY+Where)));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
                WherePixel := (3 * (IW + (sX + Where))) +
                  (BytesPerLine * (((IL + sY + Where))));
                lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
                lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
                BlueColor := lpPixelB^;
                GreenColor := lpPixelG^;
                RedColor := lpPixelR^;
         {Do not do the center ... it would be one
         and mess with the total, and the Center = 1 stuff}
{         IF ((sX+Where <> 0) AND (sY+Where<>0)) Then}
                if (sX <> Center) and (sY <> Center) then
                begin
                  case LineColor of
                    0: begin
                        if ((RCenter < (Looped * CIntervalRed)) and
                          (RedColor > (Looped * CIntervalRed)))
                          then begin
                          WherePixel := ((IW * 3) + (IL *
                            BytesPerLine));
                          lpPixelB :=
                            @PHugeByteArray(Image)^[WherePixel];
                          lpPixelG :=
                            @PHugeByteArray(Image)^[WherePixel + 1];
                          lpPixelR :=
                            @PHugeByteArray(Image)^[WherePixel + 2];
                          lpPixelB^ := 0; lpPixelG^ := 0;
                          lpPixelR^ := (Looped * CIntervalRed);
                          Caught := True;
                        end
                        else if ((RCenter > (Looped * CIntervalRed))
                          and (RedColor < (Looped * CIntervalRed)))
                          then begin
                          WherePixel := ((IW * 3) + (IL *
                            BytesPerLine));
                          lpPixelB :=
                            @PHugeByteArray(Image)^[WherePixel];
                          lpPixelG :=
                            @PHugeByteArray(Image)^[WherePixel + 1];
                          lpPixelR :=
                            @PHugeByteArray(Image)^[WherePixel + 2];
                          lpPixelB^ := 0; lpPixelG^ := 0;
                          lpPixelR^ := (Looped * CIntervalRed);
                          Caught := True;
                        end
                      end;
                    1: begin
                        if ((GCenter < (Looped * CIntervalRed)) and
                          (GreenColor > (Looped * CIntervalRed)))
                          then begin
                          WherePixel := ((IW * 3) + (IL *
                            BytesPerLine));
                          lpPixelB :=
                            @PHugeByteArray(Image)^[WherePixel];
                          lpPixelG :=
                            @PHugeByteArray(Image)^[WherePixel + 1];
                          lpPixelR :=
                            @PHugeByteArray(Image)^[WherePixel + 2];
                          lpPixelB^ := 0; lpPixelG^ := (Looped *
                            CIntervalRed);
                          lpPixelR^ := 0;
                          Caught := True;
                        end
                        else if ((GCenter > (Looped * CIntervalRed))
                          and (GreenColor < (Looped * CIntervalRed)))
                          then {SetPixel(hWorkDC, IW, IL,Color3) }
                        begin
                          WherePixel := ((IW * 3) + (IL *
                            BytesPerLine));
                          lpPixelB :=
                            @PHugeByteArray(Image)^[WherePixel];
                          lpPixelG :=
                            @PHugeByteArray(Image)^[WherePixel + 1];
                          lpPixelR :=
                            @PHugeByteArray(Image)^[WherePixel + 2];
                          lpPixelB^ := 0; lpPixelG^ := (Looped *
                            CIntervalRed);
                          lpPixelR^ := 0;
                          Caught := True;
                        end
                      end;
                    2: begin
                        if ((BCenter < (Looped * CIntervalRed)) and
                          (BlueColor > (Looped * CIntervalRed)))
                          then {SetPixel(hWorkDC, IW, IL,Color1) }
                        begin
                          WherePixel := ((IW * 3) + (IL *
                            BytesPerLine));
                          lpPixelB :=
                            @PHugeByteArray(Image)^[WherePixel];
                          lpPixelG :=
                            @PHugeByteArray(Image)^[WherePixel + 1];
                          lpPixelR :=
                            @PHugeByteArray(Image)^[WherePixel + 2];
                          lpPixelB^ := (Looped * CIntervalRed);
                          lpPixelG^ := 0; lpPixelR^ := 0;
                          Caught := True;
                        end

                        else if ((BCenter > (Looped * CIntervalRed))
                          and (BlueColor < (Looped * CIntervalRed)))
                          then {SetPixel(hWorkDC, IW, IL,Color1) }
                        begin
                          WherePixel := ((IW * 3) + (IL *
                            BytesPerLine));
                          lpPixelB :=
                            @PHugeByteArray(Image)^[WherePixel];
                          lpPixelG :=
                            @PHugeByteArray(Image)^[WherePixel + 1];
                          lpPixelR :=
                            @PHugeByteArray(Image)^[WherePixel + 2];
                          lpPixelB^ := (Looped * CIntervalRed);
                          lpPixelG^ := 0; lpPixelR^ := 0;
                          Caught := True;
                        end
                      end;
                  end; {Case}
                end; {Looped}
                if (Caught = False) then
                begin
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := 255; lpPixelG^ := 255; lpPixelR^ :=
                  255;
                end;
              end; {of If Center}
            end; {SX   Filter Width}
          end; {SY   Filter Length}
        end; {of Center}

      end; {of  Image Width}

      Per_Done := Round(100 * (IL / (ImageHeight)));
      SetP_Done1(Per_Done);
    end; {of Image Length}
    BlackOut;
    SetImage;
{IF (DeleteBitmap <> TRUE) THEN Do_Error(1231,1229);}
  end; {OF MAKE BITMAP}
end; {of Acontour line # xyz}
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}

procedure DoWireframe(CIntervalRed: integer);
begin
{}
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}


end.
